#include <bits/stdc++.h>
using namespace std;

struct Duz {
    int dole, gore;
};

int n;
vector<int> a, b;
vector<Duz> duzi;
vector<int> visited;


void input() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    duzi.resize(n);
    visited.resize(n, false);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) duzi[i] = {a[i], b[i]};
}

bool sekuSe(int a, int b) {
    Duz A = duzi[a];
    Duz B = duzi[b];
    if (A.dole > B.dole && A.gore > B.gore) return false;
    if (A.dole < B.dole && A.gore < B.gore) return false;
    return true;
}

void go(int current) {
    visited[current] = true;
    for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            if (sekuSe(current, i)) {
                go(i);
            }
        }
    }
}

void solve() {
    int brKomponenti = 0;
    for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            go(i);
            ++brKomponenti;
        }
    }
    cout << brKomponenti << endl;
}


int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    input();
    if (n<=5000)
        solve();
    else {

        int brKomponenti = 0;
        for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            for (int j = 0; j < n; ++j)
                if (!visited[j] && sekuSe(i, j)) visited[j] = true;
            ++brKomponenti;
        }
    }
    cout << brKomponenti << endl;


    }

    return 0;
}