#include <bits/stdc++.h>
using namespace std;

int N, M, Q;
vector<vector<int>> mapa;

void solve() {

    int current = 1;
    int levo, desno;

    for (int i = 0; i < M; ++i)
        if (mapa[0][i] == current) {
            levo = i; desno = i;
            current++;
            break;
        }

    while (1) {
        if (current == M*N) {
            cout << "DA" << endl; return;
        }

        if (mapa[0][desno+1] != current || desno+1 >= M) {
            if (mapa[0][levo-1] != current || levo-1 < 0) {
                cout << "NE" << endl; return;
            }
        }


        if (mapa[0][desno+1] == current && desno+1 < M) {
            ++current;
            ++desno;
        } else if ( mapa[0][levo-1] == current && levo-1 >= 0) {
            ++current;
            --levo;
        }
    }

}

void input() {
    cin >> N >> M >> Q;
    mapa.resize(N, vector<int>(M));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j)
            cin >> mapa[i][j];

    solve();
    while (Q--) {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb; xa--; ya--; xb--; yb--;
        swap(mapa[xa][ya], mapa[xb][yb]);
        solve();
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    return 0;
}