#include <bits/stdc++.h>
using namespace std;

#define seg pair<pair<int,int>,pair<int,int>>
#define l first // a = l
#define r second // b = r

bool check(seg &z, seg x) {
    if (x.l.r > z.l.l) {
        z.l.l = min(z.l.l, x.l.l);
        z.l.r = max(z.l.r, x.l.r);
        z.r.l = min(z.r.l, x.r.l);
        z.r.r = max(z.r.r, x.r.r);
        return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, c = 0; cin >> n;
    vector<pair<int,int>> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i].l;
    }
    set<pair<int,int>> s;
    for (int i = 0; i < n; i++) {
        cin >> x[i].r;
        s.insert({x[i].r, x[i].l});
    }
    sort(x.begin(), x.end());
    set<seg> v;
    v.insert({{x[0].r, x[0].r}, {x[0].l, x[0].l}});
    for (int i = 1; i < n; i++) {
        seg z; z.l.l = z.l.r = x[i].r;
        z.r.l = z.r.r = x[i].l;
        while (v.size() && check(z, *prev(v.end()))) {
            v.erase(prev(v.end()));
        }
        v.insert(z);
    }
    cout << v.size() << endl;
    return 0;
}