#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const int mod = 1e9 + 7;

void solve_1(int &n, vector<int> &a) {
    ll f = 2, s = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            s += __gcd(a[i], a[j]);
            s %= mod;
        }
        f *= i; f %= mod;
    }
    cout << f * s % mod << endl;
    exit(0);
}

void solve_2(int &n, vector<int> &a) {
    map<int,ll> m;
    vector<int> b;
    ll s = 0, f = 2;
    for (int i = 0; i < n; i++) {
        if (!m[a[i]]) {
            b.push_back(a[i]);
        }
        m[a[i]]++;
        f *= max(1, i); f %= mod;
    }
    if (b.size() > 5000) {
        return;
    }
    for (int i = 1; i < b.size(); i++) {
        for (int j = 0; j < i; j++) {
            s += m[b[i]] * m[b[j]] % mod * __gcd(b[i], b[j]) % mod;
            s %= mod;
        }
    }
    for (int i = 0; i < b.size(); i++) {
        s += m[b[i]] * (m[b[i]] - 1) / 2 % mod * b[i] % mod;
    }
    cout << f * s % mod << endl;
    exit(0);
}

int main() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (n <= 1000) {
        solve_1(n, a);
    }
    solve_2(n, a);
}