#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
#define pii pair<int,int>
#define pb push_back

using namespace std;


int n, m , q;
int cnt = 0 ;
vector<vector<bool> > tacno(300001);
vector<vector<int> > mat(300001);
vector<pii>dir(4);

bool inside ( int x , int y ) {
    return (x >= 0 && x < n && y >= 0  && y < m );
}

void proveri ( int x1 , int y1 ) {
    if ( inside(x1,y1) == false ) return;
    bool ok = false ;
    for ( auto u : dir ) {
        if ( inside(x1+u.fi, y1+u.se) ) {
            if ( mat[x1+u.fi][y1+u.se] < mat[x1][y1] ) {
                ok = true;
            }
        }
    }
    if ( tacno[x1][y1] ) {
        if ( ok == false ) cnt--;
    }
    else {
        if ( ok == true ) cnt++;
    }
    tacno[x1][y1] = ok;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    for (int i = 0 ; i < n ;i ++ ) {
        vector<int>k(m);
        vector<bool>k1(m);
        for (int j = 0 ; j < m ; j++ ) {
            cin >> k[j];
            k1[j] = false;
        }
        tacno[i] = k1;
        mat[i] = k;
    }

    dir[0] = {-1,0};
    dir[1] = {1,0};
    dir[2] = {0,-1};
    dir[3] = {0,1};

    for (int i = 0 ; i < n ; i++ ) {
        for (int j = 0 ; j < m ; j++ ) {
            proveri(i,j);
        }
    }

    if ( cnt == n*m-1 ) {
        cout << "DA" << endl;
    }
    else cout << "NE" << endl ;

    while( q-- ) {
        int x1,x2,y1,y2;
        cin >> x1 >> y1 >> x2 >> y2 ;
        x1--; y1--; x2--; y2--;
        swap(mat[x1][y1], mat[x2][y2]);
        // provera za x1y1
        proveri(x1,y1);
        proveri(x2,y2);
        for (auto u : dir) {
            proveri(x1+u.fi, y1+u.se);
            proveri(x2+u.fi, y2+u.se);
        }
        if ( cnt == n*m-1 ) {
            cout << "DA" << endl;
        }
        else cout << "NE" << endl ;
    }   


    return 0;
}