#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)

using namespace std;

class dsu{
private:
    int n;
    vector<int> comp, sz;
    vector<vector<int> > g;
    void dfs(int s, int c){
        if (this->comp[s] == c) return;
        this->comp[s] = c;
        for (int u : this->g[s])
            dfs(u, c);
    }
public:
    void init(int n){
        this->n = n;
        this->sz = vector<int>(n, 1);
        this->comp = vector<int>(n);
        for (int i = 0; i < n; i++) this->comp[i] = i;
        this->g = vector<vector<int> >(n);
    }
    void merge(int s, int u){
        if (comp[s] == comp[u]) return;
        if (this->sz[this->comp[s]] < this->sz[this->comp[u]]) swap(s, u);
        this->sz[this->comp[s]] += this->sz[this->comp[u]];
        this->sz[this->comp[u]] = 0;
        dfs(u, this->comp[s]);
    }
    int find(int s){ return this->comp[s]; }
    int clean(){
        int mp[this->n];
        memset(mp, -1, sizeof(mp));
        int m = 0;
        for (int i = 0; i < this->n; i++)
            if (this->sz[this->comp[i]])
                if (!~mp[this->comp[i]])
                    mp[this->comp[i]] = m++;
        for (int i = 0; i < n; i++)
            this->comp[i] = mp[this->comp[i]];
        return m;
    }
};


const ll LINF = 4e18;
const int mxN = 2e5+10, INF = 2e9, mod = (1 ? 1e9+7 : 998244353);
ll n, m, d, q;
array<int, 2> a[mxN];
dsu ds;

void Solve(){

    cin >> n;
    ds.init(n);
    for (int i = 0; i < n; i++)
        cin >> a[i][1];
    for (int i = 0; i < n; i++)
        cin >> a[i][0];
    sort(a, a+n);
    set<array<int, 2> > s;
    s.insert({a[0][1], 0});
    for (int i = 0; i < n; i++){
        for (auto it = s.rbegin(); it != s.rend() && (*it)[0] > a[i][1]; ++it)
            ds.merge(i, (*it)[1]);
        s.insert({a[i][1], i});
    }
    cout << ds.clean() << en;
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}