#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)

using namespace std;

const ll LINF = 4e18;
const int mxN = 3e5+10, INF = 2e9, mod = (1 ? 1e9+7 : 998244353);
ll n, m, d, q;
vector<vector<int> > a;
array<int, 2> s, b[mxN], dir[4] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};

void Solve1(){

    n = m;
    int arr[n];
    for (int i = 0; i < n; i++)
        arr[i] = a[0][i]-1;
    set<int> s;
    for (int i = 0; i < n; i++)
        if (arr[i]^i)
            s.insert(i);
    cout << (s.empty() || n<3 ? "DA" : "NE") << en;
    while (q--){
        ri(x1); ri(y1);
        x1--; y1--;
        ri(x2); ri(y2);
        x2--; y2--;
        int i = y1, j = y2;
        swap(arr[i], arr[j]);
        s.erase(i); s.erase(j);
        if (i && arr[i-1] && arr[i] < arr[i-1]) s.erase(i-1);
        if (i < n-1 && arr[i+1] && arr[i] < arr[i+1]) s.erase(i+1);
        if ((!i || arr[i] < arr[i-1]) && (i==n-1 || arr[i] < arr[i+1]) && arr[i]) s.insert(i);
        if (j && arr[j-1] && arr[j] < arr[j-1]) s.erase(j-1);
        if (j < n-1 && arr[j+1] && arr[j] < arr[j+1]) s.erase(j+1);
        if ((!j || arr[j] < arr[j-1]) && (j==n-1 || arr[j] < arr[j+1]) && arr[j]) s.insert(j);

        cout << (s.empty() || n<3 ? "DA" : "NE") << en;
    }
}

bool Valid(int x, int y){ return x >= 0 && x < n && y >= 0 && y < m; }

string Calc(){

    bool mark[n][m];
    memset(mark, 0, sizeof(mark));
    int cur = 1;
    while (cur < n*m){
        for (int i = 0; i < 4; i++)
            if (Valid(b[cur][0] + dir[i][0], b[cur][1] + dir[i][1]))
                mark[b[cur][0]+dir[i][0]][b[cur][1]+dir[i][1]] = 1;
        cur++;
        if (!mark[b[cur][0]][b[cur][1]]) return "NE";
    }
    return "DA";
}

void Solve(){

    cin >> n >> m >> q;
    a = vector<vector<int> >(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> a[i][j];
            b[a[i][j]] = {i, j};
        }
    }
    if (n==1) return Solve1();
    cout << Calc() << en;
    while (q--){
        ri(x1); ri(y1);
        x1--; y1--;
        ri(x2); ri(y2);
        x2--; y2--;
        swap(a[x1][y1], a[x2][y2]);
        swap(b[a[x1][y1]], b[a[x2][y2]]);
        cout << Calc() << en;
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}