#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)

using namespace std;

const ll LINF = 4e18;
const int mxN = 3e5+10, INF = 2e9, mod = (1 ? 1e9+7 : 998244353);
ll n, m, d, q;
vector<vector<int> > a;
set<array<int, 2> > s;
array<int, 2> dir[4] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};

bool Valid(int x, int y){ return x >= 0 && x < n && y >= 0 && y < m; }

void Update(int i, int j){

    for (int t = 0; t < 4; t++){
        int x = i+dir[t][0], y = j+dir[t][1];
        if (Valid(x, y) && a[x][y] > a[i][j]) s.erase({x, y});
    }
    if (a[i][j]) s.insert({i, j});
    for (int t = 0; t < 4; t++){
        int x = i+dir[t][0], y = j+dir[t][1];
        if (Valid(x, y) && a[i][j] > a[x][y]) s.erase({i, j});
    }
}

void Solve(){

    cin >> n >> m >> q;
    a = vector<vector<int> >(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j], a[i][j]--;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            if (a[i][j]) s.insert({i, j});
            for (int t = 0; t < 4; t++){
                int x = i+dir[t][0], y = j+dir[t][1];
                if (Valid(x, y) && a[i][j] > a[x][y]) s.erase({i, j});
            }
        }
    }
    cout << (s.empty() ? "DA" : "NE") << en;
    while (q--){
        ri(x1); ri(y1);
        x1--; y1--;
        ri(x2); ri(y2);
        x2--; y2--;
        swap(a[x1][y1], a[x2][y2]);
        Update(x1, y1);
        Update(x2, y2);
        cout << (s.empty() ? "DA" : "NE") << en;
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}