#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)

using namespace std;

const ll LINF = 4e18;
const int mxN = 2e5+10, INF = 2e9, mod = (1 ? 1e9+7 : 998244353);
namespace modop{
    vector<ll> fact, ifact;
    ll norm(ll a){ a%=mod; if(a<0)a+=mod; return a; }
    ll add(ll a, ll b){ norm(a);norm(b); a+=b; return norm(a); }
    ll mul(ll a, ll b){ norm(a);norm(b); return ((ll)(a*b))%mod; }
    ll mpow(ll base, ll exp){
        if (!exp) return 1;
        ll t = mpow(base, exp/2);
        if (exp%2) return mul(mul(t, t), base);
        return mul(t, t);
    }
    ll inv(ll a){ norm(a); return mpow(a, mod-2); }
    ll dvs(ll a, ll b){ norm(a); norm(b); return mul(a, inv(b)); }
    ll nck(ll n, ll k){ norm(n); norm(k); if (k>n) return 0; return mul(fact[n], mul(ifact[k], ifact[n-k])); }
    #define sadd(a, b) a = add(a, b)
    #define smul(a, b) a = mul(a, b)
    #define sdvs(a, b) a = dvs(a, b)
    void init_fact(int mx){
        mx++;
        fact = ifact = vector<ll>(mx+10);
        fact[0] = fact[1] = ifact[0] = ifact[1] = 1;
        for (int i = 2; i < mx; i++) fact[i] = mul(fact[i-1], i);
        ifact[mx-1] = inv(fact[mx-1]);
        for (int i = mx-2; i > 1; i--) ifact[i] = mul(i+1, ifact[i+1]);
    }
};
using namespace modop;
ll gcd(ll a, ll b){ if (!b) return a; return gcd(b, a % b); }

ll n, m, d, q, a[mxN];

void Solve(){

    cin >> n;
    init_fact(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    d = mul(2, fact[n-1]);
    ll ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < i; j++)
            sadd(ans, mul(gcd(a[i], a[j]), d));
    cout << ans << en;
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}