#include <iostream>
#include <vector>
#include <algorithm>

int size = 0;

struct cord {
	int x, y;
};

int binarys(std::vector<cord> v, int x) {
	int pos, jump = size / 2;
	int i = jump;
	while (1){
		jump /= 2;
		if (jump == 0) {
			break;
		}
		if (v[i].x > x) {
			i -= jump;
		}
		else if (v[i].x < x) {
			i += jump;
		}
		else {
			break;
		}
	}
	return i+1;
}

int main()
{
	int count = 0;
	int N; std::cin >> N;
	size = N;
	std::vector <cord> xv(N);
	for (auto &i : xv) {
		std::cin >> i.x >> i.y;
	}
	std::vector<cord> yv = xv;
	std::sort(xv.begin(), xv.begin() + N, [](cord c1, cord c2) {return c1.x < c2.x; });
	std::sort(yv.begin(), yv.begin() + N, [](cord c1, cord c2) {return c1.y < c2.y; });
	for (int i = 0; i < N; ++i) {
		cord t = xv[i];
		for (int j = binarys(yv, xv[i].x); j < N; ++j) {
			cord t1 = yv[j];
			if (t.x == t1.x && t.y == t1.y) {
				continue;
			}
			if ((t.x - t1.x) == (t.y - t1.y)) {
				count++;
			}
		}
	}
	std::cout << count;
}