using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());

            Tuple<int,int>[] tacke = new Tuple<int,int>[n];
            for (int i = 0; i < n; i++)
            {
                string[] str = Console.ReadLine().Split();
                int x = int.Parse(str[0]);
                int y = int.Parse(str[1]);
                tacke[i]=Tuple.Create(x, y);
            }

            Array.Sort(tacke, (a, b) => a.Item1.CompareTo(b.Item1));

            int br = 0;
            for (int i = 0; i < n; i++)
            {
                for (int j = i+1; j < n; j++)
                {
                    if (jeKvadrat(tacke[i],tacke[j]))
                    {
                        br++;
                    }
                }
            }
            Console.WriteLine(br);
        }

        

        static bool jeKvadrat(Tuple<int,int> kordinate1,Tuple<int,int> kordinate2)
        {
            int x1 = kordinate1.Item1;
            int y1 = kordinate1.Item2;
            int x2 = kordinate2.Item1;
            int y2 = kordinate2.Item2;
            return  y1<y2 && Math.Abs(x1-x2) == Math.Abs(y1-y2);
        }
    }
}