#include <bits/stdc++.h>
using namespace std;

vector <int> mat[300005];

int n, m;

int uradi(int i, int j){
    if(i > 1 && mat[i-1][j] < mat[i][j]) return 1;
    if(i < n && mat[i+1][j] < mat[i][j]) return 1;
    if(j > 1 && mat[i][j-1] < mat[i][j]) return 1;
    if(j < m && mat[i][j+1] < mat[i][j]) return 1;
    return 0;
}

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int q;
    cin >> n >> m >> q;
    for(int i=1; i<=n; i++){
        mat[i].push_back(0);
        for(int j=1; j<=m; j++){
            int x;
            cin >> x;
            mat[i].push_back(x);
        }
    }
    int cnt = 0;
    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            cnt += uradi(i, j);
        }
    }
    if(cnt == n*m-1) cout << "DA\n";
    else cout << "NE\n";
    while(q--){
        int i1, j1, i2, j2;
        cin >> i1 >> j1 >> i2 >> j2;
        if(i1 > 1) cnt -= uradi(i1-1, j1);
        if(i1 < n) cnt -= uradi(i1+1, j1);
        if(j1 > 1) cnt -= uradi(i1, j1-1);
        if(j1 < m) cnt -= uradi(i1, j1+1);
        cnt -= uradi(i1, j1);

        if(i2 > 1) cnt -= uradi(i2-1, j2);
        if(i2 < n) cnt -= uradi(i2+1, j2);
        if(j2 > 1) cnt -= uradi(i2, j2-1);
        if(j2 < m) cnt -= uradi(i2, j2+1);
        cnt -= uradi(i2, j2);

        swap(mat[i1][j1], mat[i2][j2]);

        if(i1 > 1) cnt += uradi(i1-1, j1);
        if(i1 < n) cnt += uradi(i1+1, j1);
        if(j1 > 1) cnt += uradi(i1, j1-1);
        if(j1 < m) cnt += uradi(i1, j1+1);
        cnt += uradi(i1, j1);

        if(i2 > 1) cnt += uradi(i2-1, j2);
        if(i2 < n) cnt += uradi(i2+1, j2);
        if(j2 > 1) cnt += uradi(i2, j2-1);
        if(j2 < m) cnt += uradi(i2, j2+1);
        cnt += uradi(i2, j2);

        if(cnt == n*m-1) cout << "DA\n";
        else cout << "NE\n";
    }
    return 0;
}