#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int add(int a, int b){
    a += b;
    if(a >= MOD) a -= MOD;
    return a;
}

int mul(int a, int b){
    return (1LL*a*b)%MOD;
}

int pw(int a, int b){
    if(b == 0) return 1;
    int res = pw(a, b/2);
    res = mul(res, res);
    if(b%2) res = mul(res, a);
    return res;
}

int a[100005];

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> a[i];
    }
    int res = 0;
    for(int i=1; i<=n; i++){
        for(int j=i+1; j<=n; j++){
            res = add(res, __gcd(a[i], a[j]));
        }
    }
    for(int i=1; i<n; i++){
        res = mul(res, i);
    }
    res = mul(res, 2);
    cout << res << "\n";
    return 0;
}