#include <iostream>
#include <vector>
#include <unordered_map>
#define MAXN 100000
#define dbg(x) cout << #x << " = " << x << endl;

using namespace std;

struct point
{
    int a, b;
};
int n;
vector<point> coords(MAXN);
vector<int> diff(MAXN);
vector<int> key;
vector<long long> fib(100000);
unordered_map<int, int> cnt;
long long res = 0;

int main()
{
    fib[0] = 1;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x, y; cin >> x >> y;
        coords[i].a = x, coords[i].b = y;
        if (x == 0 & y != 0) continue;
        diff[i] = coords[i].a - coords[i].b;
        if (cnt[diff[i]] == 0) key.push_back(diff[i]);
        cnt[diff[i]]++;
    }
    for (int i = 1; i < 100000; i++)
    {
        fib[i] = fib[i-1] + (i + 1);
    }

    for (int i = 0; i < key.size(); i++)
    {
        if (cnt[key[i]] - 2 < 0) continue;
        res += fib[cnt[key[i]] - 2];
    }

    cout << res << endl;
}