#include <bits/stdc++.h>

using namespace std;

bool check(int x11, int x12, int x21, int x22) {
    int x_min1 = min(x11, x12), x_min2 = min(x21, x22);
    int x_max1 = max(x11, x12), x_max2 = max(x21, x22);

    if (x_min2 < x_max1 && x_min1 < x_max2) {
        return true;
    }

    return false;
}

int bfs(list<int> adj[], int n) {
    int x, res = 0, s;
    queue<int> q;
    vector<bool> visited(n, 0);

    vector<bool>::iterator it = find(visited.begin(), visited.end(), 0);

    while (it != visited.end()) {
        s = distance(visited.begin(), it);
        q.push(s);
        visited[s] = true;

        while (!q.empty()) {
            x = q.front();
            q.pop();

            for (list<int>::iterator it = adj[x].begin(); it != adj[x].end(); ++it) {
                if (!visited[*it]) {
                    visited[*it] = true;
                    q.push(*it);
                }
            }
        }

        ++res;
        it = find(visited.begin(), visited.end(), 0);
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n, x_min, x_max;
    cin >> n;

    bool flag;

    int x1[n], x2[n];
    list<int> adj[n];

    for (int i = 0; i < n; ++i) {
        cin >> x1[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> x2[i];
    }

    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            flag = check(x1[i], x2[i], x1[j], x2[j]);

            if (flag) {
                adj[i].push_back(j);
                adj[j].push_back(i);
            }
        }
    }

    cout << bfs(adj, n);
}