#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

inline int mul(int a, int b) {
    return (a * 1LL * b) % MOD;
}

inline int add(int a, int b) {
    return (a + b) % MOD;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for(auto &z : v) cin >> z;

    int fact = 1;
    for(int i = 1; i <= n-1; ++i)
        fact = mul(fact, i);

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(i == j) continue;
            ans = add(ans, mul(fact, __gcd(v[i], v[j])));
        }
    }

    cout << ans;
}