#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

inline int mul(int a, int b) {
    return (a * 1LL * b) % MOD;
}

inline int add(int a, int b) {
    return (a + b) % MOD;
}

void podzadatak3(vector<int> v) {
    int n = (int)v.size();
    vector<int> elem(1005, 0);
    for(auto z : v) {
        ++elem[z];
    }

    int fa1 = 1;

    for(int i = 1; i < n; ++i) {
        fa1 = mul(fa1, i);
    }

    int ans = 0;
    for(int i = 1; i <= 1000; ++i) {
        int izraz = mul(elem[i], elem[i]-1);
        izraz = mul(izraz, fa1);
        izraz = mul(izraz, i);
        ans = add(ans, izraz);
    }

    for(int i = 1; i <= 1000; ++i) {
        for(int j = 1; j <= 1000; ++j) {
            if(i == j) continue;
            int nzd = __gcd(i, j);
            int izraz = mul(elem[i], elem[j]);
            izraz = mul(izraz, nzd);
            izraz = mul(izraz, fa1);
            ans = add(ans, izraz);
        }
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for(auto &z : v) cin >> z;

    if(*max_element(v.begin(), v.end()) <= 1000) {
        podzadatak3(v);
        return 0;
    }

    int fact = 1;
    for(int i = 1; i <= n-1; ++i)
        fact = mul(fact, i);

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(i == j) continue;
            ans = add(ans, mul(fact, __gcd(v[i], v[j])));
        }
    }

    cout << ans;
}