#include <cstdio>
#include <cstdint>
#include <climits>
#include <unordered_map>
#include <algorithm>

#define MAX_N 100000

struct Point
{
    int32_t x, y;
};

uint32_t n;
int32_t x, y;
uint64_t count;
std::unordered_map<int32_t, uint32_t> values;

int main()
{
    scanf("%u", &n);

    values.reserve(n);

    count = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%i%i", &x, &y);
        ++values[x - y];
    }

    for (auto it : values)
        count += it.second * (it.second - 1) / 2;

    printf("%llu", count);
    return 0;
}