#include <cstdio>
#include <cstdint>
#include <cstring>
#include <algorithm>

#define MAX_N 1000000
#define MAX_M 100
#define MAX_RATIO MAX_N

uint32_t n, m;
uint32_t value;
uint32_t arr[MAX_N];
uint32_t sums[MAX_N];
uint32_t limits[MAX_N];
uint32_t cursors[MAX_M * MAX_M / 2];
uint32_t sum;

int main()
{
    scanf("%u%u", &n, &m);

    sum = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%u", &value);
        uint32_t* bound = std::upper_bound(arr, arr + i, value);
        memmove(bound + 1, bound, (i - (bound - arr)) * sizeof(uint32_t));
        *bound = value;
    }

    for (int i = 0; i < n; ++i)
    {
        sum += arr[i];
        sums[i] = sum;
    }

    for (uint32_t i = 0; i * m < n; ++i)
        limits[i] = sums[n % m + i * m - 1];

    uint32_t excludeLevel = 0;
    uint32_t excluded;
    uint32_t cursorOffset;
    uint32_t excludedSum = 0;
    uint32_t i = 0;
    if (sum % m != 0 || n & m != 0)
    {
    for (; i < n; ++i)
        if ((n - sums[i]) % m == 0)
        break;

    printf("%u", sum - sums[i]);
    }
    else
        printf("%u", sum);
    return 0;
}

/*
10 3
100 90 80 70 60 50 40 30 20 10
*/