#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 5;

vector<int> a(N);
vector<int> p(N);
vector<vector<int>> g(N);
vector<long long> ans(N);
bool ok = true;

void Dfs(int u) {
  if (u != 0) {
    a[u] -= (ans[u] - ans[p[u]]);
  }
  int sz = (int) g[u].size();
  if (sz == 0) {
    return;
  }
  int cnt = 0;
  sort(g[u].begin(), g[u].end(), [&](int i, int j){return a[i] < a[j];});
  for (int v : g[u]) {
    if (cnt == 0) {
      ans[v] = ans[u] - a[u];
    } else {
      ans[v] = ans[u];
    }
    Dfs(v);
    cnt++;
  }
}

int main(){
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  //vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<bool> l(n, true);
  for (int i = 1; i < n; i++) {
    cin >> p[i];
    --p[i];
    l[p[i]] = false;
    g[p[i]].push_back(i);
  }
  Dfs(0);
  for (int i = 0; i < n; i++) {
    long long sum = 0;
    for (int j : g[i]) {
      sum += ans[i] - ans[j];
    }
    if (sum != a[i]) {
      ok = false;
    }
  }
  if (!ok) {
    cout << -1 << '\n';
    return 0;
  }
  for (int i = 0; i < n; i++) {
    if (i > 0) {
      cout << " ";
    }
    cout << ans[i];
  }
  cout << '\n';
  return 0;
}