#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 5;

vector<int> a(N);
vector<int> p(N);
vector<vector<int>> g(N);
vector<long long> ans(N);
bool ok = true;

void Dfs(int u) {
  if (u != 0) {
    ans[u] = a[p[u]];
  }
  int sz = (int) g[u].size();
  if (sz == 0) {
    return;
  }
  int cnt = 0;
  for (int v : g[u]) {
    Dfs(v);
    ans[u] -= a[v];
    cnt++;
  }
}

int main(){
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<bool> l(n, true);
  for (int i = 1; i < n; i++) {
    cin >> p[i];
    --p[i];
    l[p[i]] = false;
    g[p[i]].push_back(i);
  }
  for (int i = 0; i < n; i++) {
    long long sum = 0;
    for (int j : g[i]) {
      sum += ans[i] - ans[j];
    }
    if (sum != a[i]) {
      ok = false;
    }
  }
  Dfs(0);
  long long S = accumulate(a.begin(), a.end(), 0LL);
  if (S != 0) {
    cout << -1 << '\n';
    return 0;
  }
  for (int i = 0; i < n; i++) {
    if (i > 0) {
      cout << " ";
    }
    cout << ans[i];
  }
  cout << '\n';
  return 0;
}