#include <bits/stdc++.h>
using namespace std;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define endl '\n'
#define K int(1e3 + 1)
#define X real()
#define Y imag()
#define EPS 1e-6
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y;
#define MAN(a, b) norm(a, b)
#define EUC(a, b) abs(a, b)
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef complex<double> point;

struct seg{
    int a, b;
};

bool cmp(seg a, seg b){
    return a.a < b.a;
}

void dfs(int i, vector<vector<int>> &adj, vector<bool> &vis){
    if (vis[i]) return;
    vis[i] = 1;
    for (int i : adj[i])
        dfs(i, adj, vis);
}

void solve(){
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    vector<seg> s(n);
    for (int i = 0; i < n; i++)
        s[i] = {a[i], b[i]};
    sort(s.begin(), s.end(), cmp);
    set<pair<int, int>> p;
    vector<vector<int>> adj(n);
    vector<set<pair<int, int>>::iterator> tmp;
    for (int i = 0; i < n; i++){
        auto it = p.upper_bound({s[i].b, -1});
        p.insert({s[i].b, i});
        if (it == p.end()) continue;
        pair<int, int> lst = *p.rbegin();
        while (it != p.end()){
            tmp.push_back(it);
            lst = *(++it);
        }
        tmp.clear();
        for (auto j : tmp){
            adj[j->second].push_back(i);
            adj[i].push_back(j->second);
            p.erase(j);
        }
        adj[i].push_back(lst.second);
        adj[lst.second].push_back(i);
        p.insert(lst);
    }
    int ans = 0;
    vector<bool> vis(n, 0);
    for (int i = 0; i < n; i++)
        if (!vis[i]) { ++ans, dfs(i, adj, vis); }
    cout << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1; // cin >> t;
    while (t--) solve();

    return 0;
}