#include <bits/stdc++.h>
using namespace std;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define endl '\n'
#define K int(1e3 + 1)
#define X real()
#define Y imag()
#define EPS 1e-6
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y;
#define MAN(a, b) norm(a, b)
#define EUC(a, b) abs(a, b)
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef complex<double> point;

bool da(vector<vector<int>> &v, int n, int m){
    for (int i = 0; i < m - 1; i++)
        if (v[0][i] > v[0][i + 1])
            return 0;
    return 1;
}

void solve(){
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> v(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            cin >> v[i][j];
    cout << (da(v, n, m)? "DA" : "NE") << endl;
    int ax, ay, bx, by;
    while (q--){
        cin >> ax >> ay >> bx >> by;
        swap(v[ax][ay], v[bx][by]);
        cout << (da(v, n, m)? "DA" : "NE") << endl;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1; // cin >> t;
    while (t--) solve();

    return 0;
}