#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define endl "\n"

using namespace std;

void provera(vector<int>& a)
{
    int trazise=a.size();

    for(int l=0, r=a.size()-1;l!=r;) {

        if(a[l]==trazise) {
            l++;
            trazise--;
        }
        else if(a[r]==trazise) {
            r--;
            trazise--;
        }
        else {
            cout << "NE" << endl;
            return;
        }
    }
    cout << "DA" << endl;
}

void n1q200(int h, int n, int q)
{
    vector<int> a(n);

    for(int i=0;i<n;i++)
        cin >> a[i];

    provera(a);

    while(q--) {
        int xa,ya; cin >> xa >> ya;
        int xb,yb; cin >> xb >> yb;

        swap(a[ya-1],a[yb-1]);
        provera(a);
    }
}

bool valid(int i, int j, int h, int w)
{
    return i>=0 && i<h && j>=0 && j<w;
}

void q200(int h, int w, int q)
{
    int a[h][w];
    vector<pair<int,int>> pos(h*w);

    for(int i=0;i<h;i++) {
        for(int j=0;j<w;j++) {
            cin >> a[i][j];
            a[i][j]--;
            pos[a[i][j]] = make_pair(i,j);
        }
    }

    bool zauzeto[h][w]; memset(zauzeto, false, sizeof(zauzeto));
    bool ok=true;

    for(int i=0;i<h*w;i++) {

        int x=pos[i].first;
        int y=pos[i].second;

        if(!i) {
            zauzeto[x][y]=true;
            continue;
        }


        if( (valid(x+1,y,h,w)&&zauzeto[x+1][y]) || (valid(x-1,y,h,w)&&zauzeto[x-1][y]) || (valid(x,y+1,h,w)&&zauzeto[x][y+1]) || (valid(x,y-1,h,w)&&zauzeto[x][y-1]) ) {
            zauzeto[x][y]=true;
        }
        else {
            ok=false;
            break;
        }
    }

    if(ok) cout << "DA" << endl;
    else cout << "NE" << endl;

    while(q--) {
        int xa,ya; cin >> xa >> ya;
        int xb,yb; cin >> xb >> yb;

        swap(a[xa-1][ya-1],a[xb-1][yb-1]);
        swap( pos[a[xa-1][ya-1]], pos[a[xb-1][yb-1]] );

        ////////////////

        memset(zauzeto, false, sizeof(zauzeto));
        ok=true;

        for(int i=0;i<h*w;i++) {

            int x=pos[i].first;
            int y=pos[i].second;

            if(!i) {
                zauzeto[x][y]=true;
                continue;
            }


            if( (valid(x+1,y,h,w)&&zauzeto[x+1][y]) || (valid(x-1,y,h,w)&&zauzeto[x-1][y]) || (valid(x,y+1,h,w)&&zauzeto[x][y+1]) || (valid(x,y-1,h,w)&&zauzeto[x][y-1]) ) {
                zauzeto[x][y]=true;
            }
            else {
                ok=false;
                break;
            }
        }

        if(ok) cout << "DA" << endl;
        else cout << "NE" << endl;

    }

}

void solve()
{
    int h,w; cin >> h >> w;
    int q; cin >> q;

    if(h==1 && q<=200) {
        n1q200(h,w,q);
        return;
    }
    if(q<=200) {
        q200(h,w,q);
        return;
    }

    int a[h][w];
    for(int i=0;i<h;i++) {
        for(int j=0;j<w;j++)
            cin >> a[i][j];
    }


    while(q--) {
        int xa,ya; cin >> xa >> ya;
        int xb,yb; cin >> xb >> yb;
    }

}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int t=1; //cin >> t;
    while(t--)
        solve();

    return 0;
}