#include <bits/stdc++.h>

template<typename T>
T* napraviNiz(size_t n){
    return (T*) calloc(n, sizeof(T));
}

const int MOD = 1000000007;

int nzd(int a,int b){
    while(a%b!=0){
        int t = a;
        a = b;
        b = t%b;
    }
    return b;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cerr.tie(0);

    int n;
    int* a;

    std::cin >> n;

    a = napraviNiz<int>(n);
    int * b = napraviNiz<int>(n);

    for(int i=0;i<n;++i){
        std::cin >> a[i];
        b[i] = i;
    }

    int suma = 0;

    do {
        for(int i=1;i<n;++i){
            suma += nzd(a[b[i-1]],a[b[i]]);
            suma %= MOD;
        }
    } while(std::next_permutation(b, b+n));

    std::cout << suma;

    return 0;
}