#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
using namespace std;

bool se_seku(int a1, int b1, int a2, int b2)
{
	return (a1 < a2 && b2 < b1) || (a1 > a2 && b2 > b1);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n; cin >> n;
	vector<int> krajevi_dole(n);
	vector<int> krajevi_gore(n);
	set<int> neobradjeni;
	for (int i = 0; i < n; i++)
	{
		neobradjeni.insert(i);
		cin >> krajevi_dole[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> krajevi_gore[i];
	}

	/*vector<pair<int, int>> rastuce_duzi, opadajuce_duzi;
	vector<int> rastuce_dole, rastuce_gore, opadajuce_dole, opadajuce_gore;

	for (int i = 0; i < n; i++)
	{
		if (krajevi_dole[i] > krajevi_gore[i])
		{
			opadajuce_duzi.push_back({ krajevi_gore[i], krajevi_dole[i] });
			opadajuce_dole.push_back(krajevi_dole[i]);
			opadajuce_gore.push_back(krajevi_gore[i]);
		}
		else
		{
			rastuce_duzi.push_back({ krajevi_dole[i], krajevi_gore[i] });
			rastuce_dole.push_back(krajevi_dole[i]);
			rastuce_gore.push_back(krajevi_gore[i]);
		}
	}*/

	int br_komponenti = 0;
	while (!neobradjeni.empty())
	{
		queue<int> red;
		red.push(*neobradjeni.begin());
		neobradjeni.erase(*neobradjeni.begin());
		while (!red.empty())
		{
			int trenutna_duz = red.front(); red.pop();
			for (int duz = 0; duz < n; duz++)
			{
				if (duz != trenutna_duz && neobradjeni.find(duz) != neobradjeni.end() && se_seku(krajevi_dole[trenutna_duz], krajevi_gore[trenutna_duz], krajevi_dole[duz], krajevi_gore[duz]))
				{
					red.push(duz);
					neobradjeni.erase(duz);
				}
			}
		}
		br_komponenti++;
	}

	cout << br_komponenti;

	/*sort(rastuce_dole.begin(), rastuce_dole.end());
	sort(rastuce_gore.begin(), rastuce_gore.end());
	sort(opadajuce_dole.begin(), opadajuce_dole.end());
	sort(opadajuce_gore.begin(), opadajuce_gore.end());

	vector<vector<int>> graf(n, vector<int>());

	for (int i = 0; i < rastuce_duzi.size(); i++)
	{
		int trenutna_duz_dole = rastuce_duzi[i].first;
		int trenutna_duz_gore = rastuce_duzi[i].second;

		int od_koliko_manje_dole = lower_bound(rastuce_dole.begin(), rastuce_dole.end(), trenutna_duz_dole) - rastuce_dole.begin();
		int od_koliko_vece_gore = lower_bound(rastuce_gore.begin(), rastuce_gore.end(), trenutna_duz_gore) - rastuce_gore.begin();
		int broj_preseka = od_koliko_vece_gore - od_koliko_manje_dole;

		for (int brojac = 1; brojac <= broj_preseka; brojac++)
		{
			graf[i].push_back(i + brojac);
			graf[i + brojac].push_back(i);
		}
		
	}*/

	/*for (int i = 0; i < opadajuce_dole.size(); i++)
	{
		int od_koliko_vece_dole = lower_bound(rastuce_dole.begin(), rastuce_dole.end(), opadajuce_dole[i]) - rastuce_dole.begin();
		int od_koliko_manje_gore = 
	}*/

}