#include <bits/stdc++.h>
#define MAXN 300010
#define MAXS 10000000
#define ll long long
#define fi first
#define se second
#define mp make_pair
#define pb push_back

using namespace std;

int n, m, q, Sleft = 1, Sright = 1, onStek[MAXN];
pair<int,int> stek[MAXS];

bool bleft, bright, top, bot;
inline void addToStek(int i, int j, vector<vector<int>> a)
{
    if (i < 1 || i > n || j < 1 || j > m || onStek[a[i][j]] || a[i][j] == 1)
        return;
    if (i > 1 && a[i][j] > a[i-1][j]) top = false;
    else                              top = true;
    if (i < n && a[i][j] > a[i+1][j]) bot = false;
    else                                bot = true;
    if (j > 1 && a[i][j] > a[i][j-1]) bleft = false;
    else                              bleft = true;
    if (j < m && a[i][j] > a[i][j+1]) bright = false;
    else                                bright = true;
    if (top && bot && bleft && bright)
    {
        stek[Sright].fi = Sright-1;
        if (Sright == Sleft) stek[Sright].fi = Sright;
        stek[Sright].se = Sright+1;
        stek[Sright-1].se = Sright;
        onStek[a[i][j]] = Sright;
        Sright++;
    }
}

int aft, bef;
inline void removeFromStek(int i, int j, vector<vector<int>> a)
{
    if (i < 1 || i > n || j < 1 || j > m || !onStek[a[i][j]]) return;
    if (i > 1 && a[i][j] > a[i-1][j]) top = false;
    else                              top = true;
    if (i < n && a[i][j] > a[i+1][j]) bot = false;
    else                                bot = true;
    if (j > 1 && a[i][j] > a[i][j-1]) bleft = false;
    else                              bleft = true;
    if (j < m && a[i][j] > a[i][j+1]) bright = false;
    else                                bright = true;
    if (!(top && bot && bleft && bright))
    {
        bef = stek[onStek[a[i][j]]].fi;
        aft = stek[onStek[a[i][j]]].se;
        stek[ bef ].se = aft;
        stek[ aft ].fi = bef;
        if (onStek[a[i][j]] == Sleft)
            Sleft = aft;
        if (onStek[a[i][j]] + 1 == Sright)
            Sright = bef + 1;
        onStek[a[i][j]] = 0;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;
    vector<vector<int>> a(n+10);
    for (int i = 1; i <= n; i++)
    {
        a[i].resize(m+10);
        for (int j = 1; j <= m; j++)
            cin >> a[i][j];
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            addToStek(i, j, a);
    if (Sleft >= Sright) cout << "DA\n";
    else cout << "NE\n";
    for (int qi = 0; qi < q; qi++)
    {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb;
        swap(a[xa][ya], a[xb][yb]);

        if (onStek[a[xa][ya]]) removeFromStek(xa, ya, a);
        else                   addToStek(xa, ya, a);
        if (onStek[a[xb][yb]]) removeFromStek(xb, yb, a);
        else                   addToStek(xb, yb, a);

        int minx, miny, maxx, maxy;
        if (a[xa][ya] < a[xb][yb]) {
            minx = xa; miny = ya;
            maxx = xb; maxy = yb; }
        else {
            minx = xb; miny = yb;
            maxx = xa; maxy = ya; }
        removeFromStek(minx-1,miny, a);
        removeFromStek(minx+1,miny, a);
        removeFromStek(minx,miny-1, a);
        removeFromStek(minx,miny+1, a);
        addToStek(maxx-1,maxy, a);
        addToStek(maxx+1,maxy, a);
        addToStek(maxx,maxy-1, a);
        addToStek(maxx,maxy+1, a);
        if (Sleft >= Sright) cout << "DA\n";
        else               cout << "NE\n";
    }
    return 0;
}