#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> mat;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    mat.resize(n);
    for(int i = 0; i < n; ++i){
        mat[i].resize(m);
        for(int j = 0; j < m; ++j){
            cin >> mat[i][j];
        }
    }

    int wrong = 0;
    for(int i = 0; i < m; ++i){
        if(mat[0][i] != i + 1)
            wrong++;
    }

    if(n != 1){
        return -1;
    }

    cout << (wrong ? "NO\n" : "YES\n");
    while(q--){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2; --x1; --y1; --x2; --y2;
        swap(mat[0][y1], mat[0][y2]);

        if(mat[0][y1] == y1 + 1){
            wrong--;
        }else if(mat[0][y2] == y1 + 1){
            wrong++;
        }

        if(mat[0][y2] == y2 + 1){
            wrong--;
        }else if(mat[0][y1] == y2 + 1){
            wrong++;
        }

        bool ok = true;
        for(int i = 0; i < m; ++i){
            if(mat[0][i] != i + 1){
                ok = false;
                break;
            }
        }
        cout << (ok ? "YES\n" : "NO\n");
        //cout << (wrong != 0 ? "NO\n" : "YES\n");
    }
    return 0;
}

/*
1 11 11
1 2 3 4 7 8 6 5 10 11 9
1 5 1 8
1 6 1 7
1 7 1 8
1 9 1 11
1 1 1 2
1 10 1 11
1 2 1 1
1 2 1 3
1 5 1 4
1 3 1 2
1 4 1 5
*/