#include <bits/stdc++.h>
using namespace std;

#define ll long long

const int N = 100005;
const int MOD = 1000000007;
int n;

ll fakt[N];
ll a[N];

void init(){
    fakt[0] = 1;
    for(int i = 1; i < N; ++i){
        fakt[i] = (fakt[i - 1] * i) % MOD;
    }
}

void solve1(){
    ll res = 0;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < i; ++j){
            res += (2 * __gcd(a[i], a[j]) * fakt[n - 1]) % MOD;
            res %= MOD;
        }
    }
    cout << res << "\n";
}

map<int, int> mp;
void solve2(){
    for(int i = 0; i < n; ++i){
        mp[a[i]]++;
    }

    vector<pair<int, int>> vk;
    for(auto x : mp){
        vk.push_back(x);
    }

    int m = vk.size();
    ll res = 0;
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < i; ++j){
            ll x = (__gcd(vk[i].first, vk[j].first) * fakt[n - 1]) % MOD;
            x = (2 * x) % MOD;
            x = (x * vk[i].second * vk[j].second) % MOD;
            res += x;
            res %= MOD;
        }
        ll x = (vk[i].second * (vk[i].second - 1)) % MOD;
        x = (x * fakt[n - 1]) % MOD;
        x = (x * vk[i].first) % MOD;
        res += x;
        res %= MOD;
    }



    cout << res << "\n";
}

int main()
{
    init();

    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }

    if(n <= 1000){
        solve1();
    }else{
        solve2();
    }


    return 0;
}