#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef pair<int, int> pi;
typedef vector<pi> vp;
typedef vector<double> vd;
typedef vector<long double> vld;

bool ok(int a, int b, int c, int d){
    if (a <= c && b >= d) return 1;
    if (a >= c && b <= d) return 1;
    return 0;
}

const int maxn = 5010;
vi vis(maxn), e[maxn];

void spoji(int a, int b){
    e[a].push_back(b);
    e[b].push_back(a);
}

void dfs(int x){
    vis[x] = 1;

    for (int i : e[x])
        if (!vis[i])
            dfs(i);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int n;
    cin >> n;

    vi a(n);
    for (auto& i : a)
        cin >> i;

    vi b(n);
    for (auto& i : b)
        cin >> i;

    for (int i = 0; i < n; ++i){
        for (int j = i+1; j < n; ++j){
            if (ok(a[i],b[i],a[j],b[j])){
                spoji(i,j);
            }
        }
    }

    int sol = 0;
    for (int i = 0; i < n; ++i){
        if (!vis[i]){
            ++sol;
            dfs(i);
        }
    }

    cout << sol << '\n';
}