#include <bits/stdc++.h>
using namespace std;

pair<int, int> ar[300005];

int bit[300005];
unordered_set<int> s;
unordered_map<int, int> mp;
int cur;

void update(int v, int k) {
    while (v <= cur) {
        bit[v] += k;
        v += (k & (-k));
    }
}

int query(int v) {
    int res = 0;
    while (v) {
        res += bit[v];
        v -= (v & (-v));
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int cnt = 1;
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> ar[i].first;
        s.insert(ar[i].first);
    }
    for (int i = 0; i < n; i++) {
        cin >> ar[i].second;
        s.insert(ar[i].second);
    }
    for (int i : s) {
        mp[i] = ++cur;
    }
    for (int i = 0; i < n; i++) {
        ar[i].first = mp[ar[i].first];
        ar[i].second = mp[ar[i].second];
    }
    sort(ar, ar + n);
    for (int i = 1; i < n; i++) {
        update(ar[i].second, 1);
    }
    int mx = ar[0].second;
    for (int i = 1; i < n; i++) {
        update(ar[i].second, -1);
        if (ar[i].first != ar[i - 1].first && query(ar[i].second) <= 0 && mx < ar[i].second) {
            cnt++;
        }
        mx = max(ar[i].second, mx);
    }
    cout << cnt << '\n';
    return 0;
}