#include <bits/stdc++.h>

using namespace std;
const int N = 300005;
#define ll long long
pair<int, int> b[N];
bool visited[N];
int niz[N];
int seg1[4 * N], seg2[4 * N];

void build(int u, int l, int r, int m) {
    if (l == r) {
        if (l < m - 1 && niz[l] < niz[l + 1])
            seg1[u] = 1;
        if (l > 0 && niz[l] < niz[l - 1])
            seg2[u] = 1;
        return;
    }
    int mid = l + r >> 1;
    build(u * 2 + 1, l, mid, m);
    build(u * 2 + 2, mid + 1, r, m);
    seg1[u] = seg1[u * 2 + 1] + seg1[u * 2 + 2];
    seg2[u] = seg2[u * 2 + 1] + seg2[u * 2 + 2];
}

int print(int u, int l, int r, int L, int R, bool p) {
    if (r < L || l > R)
        return 0;
    if (l >= L && r <= R) {
        if (p)
            return seg1[u];
        else
            return seg2[u];
    }
    int mid = l + r >> 1;
    return print(u * 2 + 1, l, mid, L, R, p) + print(u * 2 + 2, mid + 1, r, L, R, p);
}

void upd(int u, int l, int r, int x, int m) {
    if (x >= m || x <= 0)
        return;
    if (l == r && l == x) {
        if (x > 0) {
            if (niz[x - 1] > niz[x])
                seg2[x] = 1;
            else
                seg2[x] = 0;
        }
        if (x < m) {
            if (niz[x + 1] > niz[x])
                seg1[x] = 1;
            else
                seg1[x] = 0;
        }
        return;
    }
    int mid = l + r >> 1;
    if (l <= x && x <= mid)
        upd(u * 2 + 1, l, mid, x, m);
    else
        upd(u * 2 + 2, mid + 1, r, x, m);
    seg1[u] = seg1[u * 2 + 1] + seg1[u * 2 + 2];
    seg2[u] = seg2[u * 2 + 1] + seg2[u * 2 + 2];
}

void reset() {
    for (int i = 0; i < N; i++)
        visited[i] = 0;
}

int main()
{
    int n, m, q;
    ios_base::sync_with_stdio(true);
    cin.tie(0);
    cin >> n >> m >> q;
    int a[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x;
            cin >> a[i][j];
            if (n == 1)
                niz[j] = a[i][j];
            b[a[i][j]] = {i, j};
        }
    }
    if (q <= 200) {
        pair<int, int> x, y;
        for (int i = 0; i < q + 1; i++) {
            reset();
            visited[1] = true;
            bool p = false;
            for (int j = 1; j <= m * n; j++) {
                int k1 = b[j].first, k2 = b[j].second;
                if (k1 - 1 >= 0)
                    visited[a[k1 - 1][k2]] = true;
                if (k2 - 1 >= 0)
                    visited[a[k1][k2 - 1]] = true;
                if (k1 + 1 < n)
                    visited[a[k1 + 1][k2]] = true;
                if (k2 + 1 < m)
                    visited[a[k1][k2 + 1]] = true;
                if (!visited[j]) {
                    cout << "NE" << endl;
                    p = true;
                    break;
                }
            }
            if(!p)
                cout << "DA" << endl;
            if (i == q)
                break;
            cin >> x.first >> x.second >> y.first >> y.second;
            x.first--, x.second--, y.first--, y.second--;
            swap(b[a[x.first][x.second]], b[a[y.first][y.second]]);
            swap(a[x.first][x.second], a[y.first][y.second]);
        }
        return 0;
    }
    if (n == 1) {
        build(0, 0, m - 1, m);
        pair<int, int> x, y;
        int kec = b[1].second;
        int brs = 0;
        brs += print(0, 0, m - 1, 0, kec, 1);
        brs += print(0, 0, m - 1, kec, m - 1, 0);
        if (!brs)
            cout << "DA" << endl;
        else
            cout << "NE" << endl;
        for (int i = 0; i < q; i++) {
            brs = 0;
            cin >> x.first >> x.second >> y.first >> y.second;
            x.first--, x.second--, y.first--, y.second--;
            swap(b[niz[x.second]], b[niz[y.second]]);
            swap(niz[x.second], niz[y.second]);
            kec = b[1].second;
            int p1 = x.second, p2 = y.second;
            upd(0, 0, m - 1, p1, m);
            upd(0, 0, m - 1, p1 + 1, m);
            upd(0, 0, m - 1, p1 - 1, m);
            upd(0, 0, m - 1, p2, m);
            upd(0, 0, m - 1, p2 + 1, m);
            upd(0, 0, m - 1, p2 - 1, m);
            brs += print(0, 0, m - 1, 0, kec, 1);
            brs += print(0, 0, m - 1, kec, m - 1, 0);
            if (!brs)
                cout << "DA" << endl;
            else
                cout << "NE" << endl;
        }
        return 0;
    }
    return 0;
}