#include <stdio.h>
#include <stdlib.h>

struct razlika{
    long long razlika;
    int br;
};

int bin(struct razlika *razlike, int len, long long vrednost) {
    int l=0;
    int d=len - 1;
    int pom = (l+d)/2;
    while(l <= d) {
        pom = (l+d)/2;
        if(razlike[pom].razlika == vrednost) { return pom; }
        if(razlike[pom].razlika > vrednost) {
            d = pom - 1;
        } else {
            l = pom + 1;
        }
    }
    int i;
    for (i = 0; i < len; ++i) {
        if(razlike[i].razlika > vrednost) {
            return i;
        }
    }
    return len;
}

void ubaci(struct razlika *razlike, int len, int poz, long long vrednost) {
    for (int i = len; i >= poz; --i) {
        razlike[i].razlika = razlike[i-1].razlika;
        razlike[i].br = razlike[i-1].br;
    }
    razlike[poz].razlika = vrednost;
    razlike[poz].br = 1;
}

int main() {
    int n;
    scanf("%d", &n);

    struct razlika *razlike = malloc(n*sizeof(*razlike));
    int len = 0;
    long long br = 0;
    long long x, y, razlika;
    for (int i = 0; i < n; ++i) {
        scanf("%lld%lld", &x, &y);
        razlika = x - y;

        if(len == 0) {
            razlike[0].razlika = razlika;
            razlike[0].br = 1;
            ++len;
            continue;
        }
        int ind = bin(razlike, len, razlika);
        if(razlike[ind].razlika == razlika) {
            br += razlike[ind].br;
            ++(razlike[ind].br);
            continue;
        }
        ubaci(razlike, len, ind, razlika);
        ++len;

    }

    printf("%lld\n", br);

    return 0;
}