#include <bits/stdc++.h>
using namespace std;

#define ends '\n'
#define vec vector
#define sp ' '
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define pb push_back
#define fun function
#define sz(x) ((int)(x.size()))

const long long MOD = 1e9 + 7;

typedef long long ll;
typedef long double ld;

const string DA = "DA", NE = "NE";

int main()
{

    int n, m, q;
    cin >> n >> m >> q;

    vec<array<int, 2>> d;
    d.pb({{0, 0}});
    d.pb({{1, 0}});
    d.pb({{0, 1}});
    d.pb({{-1, 0}});
    d.pb({{0, -1}});

    vec<vec<int>> a(n, vec<int>(m));
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            cin >> a[i][j];

    vec<vec<bool>> safe(n, vec<bool> (m));

    int num = 0;

    fun<bool(int, int)> ch = [&] (int i, int j){
        if(i > 0 && a[i - 1][j] < a[i][j]) return true;
        if(j > 0 && a[i][j - 1] < a[i][j]) return true;
        if(i < n - 1 && a[i + 1][j] < a[i][j]) return true;
        if(j < m - 1 && a[i][j + 1] < a[i][j]) return true;

        return false;
    };

    fun<void(int, int)> ch2 = [&] (int i, int j){
        if(i < 0 || j < 0 || i >= n || j >= m)
            return;
        bool ok1 = safe[i][j];
        bool ok2 = ch(i, j);

        if(ok1 && !ok2) --num;
        if(!ok1 && ok2) ++num;

        a[i][j] = ok2;

    };

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j){
            safe[i][j] = ch(i, j);
            num += safe[i][j];
        }

    cout << (num == n * m - 1 ? DA : NE) << ends;

    int x1, y1, x2, y2;
    for(int Q = 1; Q <= q; ++Q){
        cin >> x1 >> y1 >> x2 >> y2;
        --x1, --y1, --x2, --y2;

        swap(a[x1][y1], a[x2][y2]);

        for(auto ar : d)
            ch2(x1 + ar[0], y1 + ar[1]);
        for(auto ar : d)
            ch2(x2 + ar[0], y2 + ar[1]);

        cout << (num == n * m - 1 ? DA : NE) << ends;
    }


}