#include <bits/stdc++.h>
using namespace std;

#define ends '\n'
#define vec vector
#define sp ' '
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define pb push_back
#define fun function
#define sz(x) ((int)(x.size()))

const long long MOD = 1e9 + 7;

typedef long long ll;
typedef long double ld;

ll sum (ll x, ll y){
    return ((x % MOD) + (y % MOD)) % MOD;
}

ll mul (ll x, ll y){
    return ((x % MOD) * (y % MOD)) % MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vec<ll> a(n);
    bool ok = true;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        if(a[i] > 1000)
            ok = false;
    }

    sort(all(a));
    int cnt = 1;
    for(int i = 1; i < n; ++i){
        if(a[i] != a[i - 1])
            ++cnt;
    }

    vec<ll> fac(n + 5);
    fac[0] = 1;
    for(ll i = 1; i <= n; ++i){
        fac[i] = mul(i, fac[i - 1]);
    }

    ll base = mul((ll)n - 1, fac[n - 2]);
    ll ans = 0;

    if(cnt == 1){
        ans = mul(mul(base, mul((ll)n, (ll)n - 1)), a[0]);
    }else if(cnt == 2){
        ll cnt1 = 1, cnt2 = 0;
        bool ok = true;
        for(int i = 1; i < n; ++i){
            if(a[i] != a[i - 1])
                ok = false;
            if(ok) ++cnt1;
            else ++cnt2;
        }
        //cout << mul(base, a[n - 1]) << ends;
        //cout << mul((ll)n, (ll)n - 1) << ends;
        ans = mul(mul(base, a[0]), mul((ll)cnt1, (ll)cnt1 - 1));
        ans = sum(ans, mul(mul(base, a[n - 1]), mul((ll)cnt2, (ll)cnt2 - 1)));
        ans = sum(ans, mul(mul(base, (ll)__gcd(a[0], a[n - 1])), mul(2LL, mul(cnt1, cnt2))));
    }else if(ok && n > 1000){
        ans = 0;
        vec<array<int, 2>> a2;
        int i = 0;
        while(i < n){
            int j = i;
            while(j < n && a[j] == a[i])
                ++j;
            a2.pb({{a[i], j - i}});
            i = j;
        }

        int m = sz(a2);
        for(int i = 0; i < m; ++i){
            for(int j = i; j < m; ++j){
                ll g = (ll)__gcd(a2[i][0], a2[j][0]);
                if(i == j)
                    ans = sum(ans, mul(mul(base, g), mul((ll)a2[i][1], (ll)a2[i][1] - 1)));
                else
                    ans = sum(ans, mul( mul( mul(base , g) , mul ((ll)a2[i][1], (ll)a2[j][1] )) , 2LL));
            }
        }

    }else{
        for(int i = 0; i < n; ++i)
            for(int j = i + 1; j < n; ++j)
                ans = sum(ans, mul(mul((ll)__gcd(a[i], a[j]), base), 2LL));
    }

    cout << ans << ends;
}