#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool sCords[1002][1002];

int main()
{
    int n;
    cin >> n;
    vector<pair<int,int>> cords(n);
    bool sm = true;
    for (int i = 0; i < n; i++) {
        cin >> cords[i].first >> cords[i].second;
        if (cords[i].first > 1000 || cords[i].second > 1000) sm = false;
        sCords[cords[i].first][cords[i].second] = true;
    }

    sort(cords.begin(), cords.end());

    int ans = 0;

    if (sm) {
        for (auto x : cords) {
            int cx = x.first;
            int cy = x.second;
            int d = 1;
            while (cx+d <= 1000 && cy+d <= 1000) {
                if (sCords[cx+d][cy+d]) ans++;
                d++;
            }
        }
    } else {
        // ++++++++++++++++++
        for (int i = 0; i < n-1; i++) {
            for (int j = i+1; j < n; j++) {
                if (abs(cords[i].first - cords[j].first) == abs(cords[i].second - cords[j].second) && cords[i].first < cords[j].first && cords[i].second < cords[j].second) {
                    ans++;
                }
            }
        }
        // ================
    }

    cout << ans << endl;

    return 0;
}