#include <bits/stdc++.h>

using namespace std;

int n, m, x;
vector< vector<int> > mat;
int br = 0;

bool check(int i, int j) {

    if(i < 0 || i >= n || j < 0 || j >= m)
        return 1;

    int a = mat[i][j];
    if(a == 1)
        return 1;
    int x = j ? mat[i][j - 1] : n + m + 1;
    int y = i ? mat[i - 1][j] : n + m + 1;
    int z = i < n - 1 ? mat[i + 1][j] : n + m + 1;
    int q = j < m - 1 ? mat[i][j + 1] : n + m + 1;
    return (a > x || a > y || a > z || a > q) ? 1 : 0;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> n >> m >> q;

    mat.resize(n);
    for(int i = 0; i < n; i++) {
        mat[i].resize(m);
        for(int j = 0; j < m; j++)
            cin >> mat[i][j];
    }
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            br += check(i, j);
    if(br == n * m)
        cout << "DA" << endl;
    else
        cout << "NE" << endl;

    while(q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--; y1--; x2--; y2--;

        br -= check(x1, y1) + check(x1 - 1, y1) + check(x1, y1 - 1) + check(x1 + 1, y1) + check(x1, y1 + 1);
        br -= check(x2, y2) + check(x2 - 1, y2) + check(x2, y2 - 1) + check(x2 + 1, y2) + check(x2, y2 + 1);
        int temp = mat[x1][y1];
        mat[x1][y1] = mat[x2][y2];
        mat[x2][y2] = temp;
        br += check(x1, y1) + check(x1 - 1, y1) + check(x1, y1 - 1) + check(x1 + 1, y1) + check(x1, y1 + 1);
        br += check(x2, y2) + check(x2 - 1, y2) + check(x2, y2 - 1) + check(x2 + 1, y2) + check(x2, y2 + 1);
        if(br == n * m)
            cout << "DA" << endl;
        else
            cout << "NE" << endl;
    }
    return 0;
}