#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if(a >= mod)
        a -= mod;
    return a;
}

int mul(int a, int b) {
    return (ll)a * b % mod;
}

int gcd(int a, int b) {

    if(b == 0)
        return a;
    return gcd(b, a % b);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    int arr[n];
    for(int i = 0; i < n; i++)
        cin >> arr[i];

    int fact = 1;
    for(int i = 1; i <= n - 2; i++)
        fact = mul(fact, i);

    int m = mul(2, mul(n - 1, fact));
    int ans = 0;
    for(int i = 0; i < n - 1; i++)
        for(int j = i + 1; j < n; j++)
            ans = add(ans, mul(m, gcd(arr[i], arr[j])));
    cout << ans << endl;
    return 0;
}