#include <bits/stdc++.h>
using namespace std;

int n, m, q;
unordered_map<int, int> a[300005];
unordered_map<int, bool> isOkay[300005];
int di[5] = {0, -1, 0, 1, 0};
int dj[5] = {0, 0, 1, 0, -1};
int cnt;

bool checkIfOkay(int i, int j)
{
    bool ret = false;

    if((i - 1 >= 1 && a[i - 1][j] < a[i][j])
    || (j + 1 <= m && a[i][j + 1] < a[i][j])
    || (i + 1 <= n && a[i + 1][j] < a[i][j])
    || (j - 1 >= 1 && a[i][j - 1] < a[i][j])){
        ret = true;
    }

    if(a[i][j] == 1){
        ret = true;
    }

    return ret;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> q;

    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            cin >> a[i][j];
        }
    }

    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            isOkay[i][j] = checkIfOkay(i, j);
            if(!isOkay[i][j]){++cnt;}
        }
    }

    if(cnt == 0){cout << "DA\n";}
    else{cout << "NE\n";}
    while(q--){
        int i1, j1, i2, j2;
        cin >> i1 >> j1 >> i2 >> j2;

        swap(a[i1][j1], a[i2][j2]);

        for(int k1 = 1; k1 <= 2; ++k1){
            for(int k = 0; k < 5; ++k){
                int i, j;
                if(k1 == 1){
                    i = i1 + di[k];
                    j = j1 + dj[k];
                }
                else{
                    i = i2 + di[k];
                    j = j2 + dj[k];
                }

                if(!(i >= 1 && i <= n && j >= 1 && j <= m)){continue;}

                if(checkIfOkay(i, j) && !isOkay[i][j]){
                    --cnt;
                    isOkay[i][j] = true;
                }
                else if(!checkIfOkay(i, j) && isOkay[i][j]){
                    ++cnt;
                    isOkay[i][j] = false;
                }
            }
        }

        if(cnt == 0){cout << "DA\n";}
        else{cout << "NE\n";}
    }

    return 0;
}