#include <stdlib.h>
#include <stdio.h>

#define MOD 1000000007

long nzd (long x, long y)
{
    long t;

    while (y>0)
    {
        t = x;
        x = y;
        y = t % y;
    }

    return x;
}

int main()
{
    long N;
    scanf ("%ld", &N);

    long A[N];
    long minA = 1000001, maxA = 0;
    for (long i=0; i<N; i++)
    {
        scanf ("%ld", &A[i]);
        if (A[i]<minA)
            minA = A[i];
        if (A[i]>maxA)
            maxA = A[i];
    }


    if (N<=1000)
    {
        long long res = 0;
        for (long i=0; i<N; i++)
            for (long j=i+1; j<N; j++)
                res = (res + nzd (A[i],A[j])) % MOD;

        long long fact = 1;
        for (long i=2; i<N; i++)
            fact = (fact * i) % MOD;
        fact = (fact*2) % MOD;
        res = (res*fact) % MOD;

        printf ("%lld", res);
    }
    else if (maxA <= 1000)
    {
        long cnt[1001];
        for (long i=1; i<=1000; i++)
            cnt[i] = 0;
        for (long i=0; i<N; i++)
            cnt[ A[i] ]++;

        long long res = 0, temp;
        for (long i=1; i<=1000; i++)
            for (long j=i+1; j<=1000; j++)
                if (cnt[i]*cnt[j]>0)
                {
                    temp = nzd (i,j);
                    temp = (temp*cnt[i]) % MOD;
                    temp = (temp*cnt[j]) % MOD;
                    res = (res + temp) % MOD;
                }

        for (long i=1; i<=1000; i++)
        {
            temp = ((cnt[i]*(cnt[i]-1))/2) % MOD;
            temp = (temp*i) % MOD;
            res = (res + temp) % MOD;
        }

        long long fact = 1;
        for (long i=2; i<N; i++)
            fact = (fact * i) % MOD;
        fact = (fact*2) % MOD;
        res = (res*fact) % MOD;

        printf ("%lld", res);
    }
    else
    {
        long long res = 0, temp;

        long cntMin = 0, cntMax = 0;
        for (long i=0; i<N; i++)
            if (A[i] = minA)
                cntMin++;
            else
                cntMax++;

        temp = nzd(minA, maxA);
        temp = (temp*cntMin) % MOD;
        temp = (temp*cntMax) % MOD;
        res = (res + temp) % MOD;

        temp = ((cntMin*(cntMin-1))/2) % MOD;
        temp = (temp*minA) % MOD;
        res = (res + temp) % MOD;

        temp = ((cntMax*(cntMax-1))/2) % MOD;
        temp = (temp*maxA) % MOD;
        res = (res + temp) % MOD;

        printf ("%lld", res);
    }

    return 0;
}