#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const int mxN = 1e6+5;
const int mod = 1e9+7;

ll gcd(ll a, ll b)
{
    if(b == 0) return a;
    return gcd(b, a%b);
}
ll powb(ll a, ll x)
{
    a %= mod;
    ll ret = 1;
    while(x)
    {
        if(x&1) ret = ret*a%mod; ///vibe check ovo
        x >>= 1;
        a=a*a%mod;
    }
    return ret;
}
ll inv(ll x, ll m)
{
    return powb(x, m-2);
}
ll a[mxN];
ll cnt[mxN];
ll f[mxN];
ll t[mxN];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    f[0] = 1;
    for(int i = 1; i < mxN; i++)
    {
        f[i] = f[i-1]*i%mod;
    }

    bool greater1000 = 0;
    int n; cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        cnt[a[i]]++;
        if(a[i] > 1000) greater1000 = true;
    }
    ll ans = 0;
    if(n <= 1000)
    {
        for(int i = 0; i < n; i++)
        {
            for(int j = i+1; j < n; j++)
            {
                ll gc = gcd(a[i], a[j])*2;
                ans += (gc*(n-1)%mod)*f[n-2]%mod;
                ans %= mod;
            }
        }
        cout << ans;
        return 0;
    }
    else if(!greater1000)
    {
        for(int i = 1; i <= 1000; i++)
        {
            ans += ((((cnt[i]*(cnt[i]-1))%mod)*(n-1)%mod)*f[n-2]%mod)*i%mod;
            for(int j = i+1; j <= 1000; j++)
            {
                ll gc = gcd(i, j);
                ans += ((gc*(cnt[i]*cnt[j]*2)%mod)*(n-1)%mod)*f[n-2]%mod;
                ans %= mod;
            }
        }
        cout << ans;
        return 0;
    }
    else
    {
        int v1 = -1, v2 = -1;
        for(int i = 0; i < n; i++)
        {
            if(v1 == -1) v1 = a[i];
            else if(v1 != a[i]) v2 = a[i];
        }
        if(v2 == -1)
        {
            cout << ((f[n]*v1%mod)*(n-1)%mod);
            return 0;
        }
        else
        {
            ans += (((v1*cnt[v1]%mod)*(cnt[v1]-1)%mod)*(n-1)%mod)*f[n-2]%mod;
            ans %= mod;
            ans += (((v2*cnt[v2]%mod)*(cnt[v2]-1)%mod)*(n-1)%mod)*f[n-2]%mod;
            ans %= mod;
            ans += (((gcd(v1, v2)*cnt[v1]%mod)*cnt[v2]*2%mod)*(n-1)%mod)*f[n-2]%mod;
            cout << (ans%mod);
            return 0;
        }
    }
}