#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define IOS ios_base::sync_with_stdio(false); cin.tie(nullptr);

const int N = 3e5 + 5;

vector<vector<int>> a;
vector<vector<bool>> b;
pair<int, int> pos[N];

int dfs(int x, int y, int n, int m, int ct) {
    b[x][y] = true;
    if (ct == n * m) {
        return ct;
    }
    x = pos[ct + 1].first;
    y = pos[ct + 1].second;
    for (int dx = -1; dx <= 1; dx++) {
        for (int dy = -1; dy <= 1; dy++) {
            if (abs(dx) + abs(dy) == 2 || x + dx < 0 || x + dx == n || y + dy < 0 || y + dy > m) {
                continue;
            }
            if (b[x + dx][y + dy] == true) {
                return dfs(x, y, n, m, ct + 1);
            }
        }
    }
    return ct;
}

void reset(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i][j] = false;
        }
    }
}

int main() {
    IOS;
    int n, m, q;
    cin >> n >> m >> q;
    a.assign(n, vector<int>());
    b.assign(n, vector<bool>(m, false));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int k;
            cin >> k;
            a[i].push_back(k);
            pos[k] = {i, j};
        }
    }
    if (n != 1 && q <= 200) {
        reset(n, m);
        int ans = dfs(pos[1].first, pos[1].second, n, m, 1);
        if (ans == n * m) {
            cout << "DA" << endl;
        } else {
            cout << "NE" << endl;
        }
        for (int i = 0; i < q; i++) {
            int xa, ya, xb, yb;
            cin >> xa >> ya >> xb >> yb;
            xa--, ya--, xb--, yb--;

            int l = a[xa][ya];
            pos[l] = {xb, yb};
            int r = a[xb][yb];
            pos[r] = {xa, ya};

            swap(a[xa][ya], a[xb][yb]);
            reset(n, m);

            ans = dfs(pos[1].first, pos[1].second, n, m, 1);
            if (ans == n * m) {
                cout << "DA" << endl;
            } else {
                cout << "NE" << endl;
            }
        }

    }



    return 0;

}