#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define IOS ios_base::sync_with_stdio(false); cin.tie(nullptr);

const int N = 3e5 + 5;

vector<vector<int>> a;
vector<vector<bool>> b;
pair<int, int> pos[N];
int arr[N];

set<int> badright;
set<int> badleft;

int dfs(int x, int y, int n, int m, int ct) {
    b[x][y] = true;
    if (ct == n * m) {
        return ct;
    }
    x = pos[ct + 1].first;
    y = pos[ct + 1].second;
    for (int dx = -1; dx <= 1; dx++) {
        for (int dy = -1; dy <= 1; dy++) {
            if (abs(dx) + abs(dy) == 2 || x + dx < 0 || x + dx == n || y + dy < 0 || y + dy > m) {
                continue;
            }
            if (b[x + dx][y + dy] == true) {
                return dfs(x, y, n, m, ct + 1);
            }
        }
    }
    return ct;
}

void reset(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i][j] = false;
        }
    }
}

string query(int loc) {
    if (*badright.rbegin() > loc) {
        return "NE";
    }
    if (*badleft.begin() < loc) {
        return "NE";
    }
    return "DA";
}

int main() {
    IOS;
    int n, m, q;
    cin >> n >> m >> q;

    if (q <= 200) {
        a.assign(n, vector<int>());
        b.assign(n, vector<bool>(m, false));
        reset(n, m);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int k;
                cin >> k;
                a[i].push_back(k);
                pos[k] = {i, j};
            }
        }
        int ans = dfs(pos[1].first, pos[1].second, n, m, 1);
        if (ans == n * m) {
            cout << "DA" << endl;
        } else {
            cout << "NE" << endl;
        }
        for (int i = 0; i < q; i++) {
            int xa, ya, xb, yb;
            cin >> xa >> ya >> xb >> yb;
            xa--, ya--, xb--, yb--;

            int l = a[xa][ya];
            pos[l] = {xb, yb};
            int r = a[xb][yb];
            pos[r] = {xa, ya};

            swap(a[xa][ya], a[xb][yb]);
            reset(n, m);

            ans = dfs(pos[1].first, pos[1].second, n, m, 1);
            if (ans == n * m) {
                cout << "DA" << endl;
            } else {
                cout << "NE" << endl;
            }
        }
        return 0;
    } else {
        if (n != 1) {
            return 0;
        }
        n = m;
        int loc;
        for (int i = 0; i < n; i++) {
            cin >> arr[i];
            if (arr[i] == 1) {
                loc = i;
            }
        }

        int last = 0;
        for (int i = 0; i < n; i++) {

            if (arr[i] < last) {
                badright.insert(i);
            }
            last = arr[i];
        }
        last = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (arr[i] < last) {
                badleft.insert(i);
            }
            last = arr[i];
        }

        cout << query(loc) << endl;

        for (int i = 0; i < q; i++) {
            int f1, f2, l, r;
            cin >> f1 >> l >> f2 >> r;
            return 0;
            l--, r--;
            if (l > r) {
                swap(l, r);
            }
            if (loc == l) {
                loc = r;
            } else if (loc == r) {
                loc = l;
            }


            if (l != 0 && arr[r] > arr[l - 1]) {
                badleft.insert(l - 1);
                badright.erase(l);

            }
            if (l != 0 && arr[r] < arr[l - 1]) {
                badright.insert(l);
                badleft.erase(l - 1);
            }

            if (l != n - 1 && arr[r] > arr[l + 1]) {
                badright.insert(l + 1);
                badleft.erase(l);
            }
            if (l != n - 1 && arr[r] < arr[l + 1]) {
                badleft.insert(l);
                badright.erase(l + 1);
            }


            if (r != 0 && arr[l] > arr[r - 1]) {
                badleft.insert(l - 1);
                badright.erase(l);

            }
            if (r != 0 && arr[l] < arr[r - 1]) {
                badright.insert(l);
                badleft.erase(l - 1);
            }

            if (r != n - 1 && arr[l] > arr[r + 1]) {
                badright.insert(l + 1);
                badleft.erase(l);
            }
            if (r != n - 1 && arr[l] < arr[r + 1]) {
                badleft.insert(l);
                badright.erase(l + 1);
            }

            swap(arr[l], arr[r]);

            cout << query(loc) << endl;

        }
        return 0;


    }



    return 0;

}