#include <bits/stdc++.h>
using namespace std;

int N, M, Q;
vector<vector<int>> mapa;

void solve() {

    int current = 1;
    bool napred = true;
    for (int i = 0; i < M; ++i) {
        if (mapa[0][i] != current) { napred = false; break; }
        current++;
    }
    if (napred == true)
        cout << "DA" << endl;
    else {
        current = 1;
        for (int i = M-1; i >= 0; --i) {
            if (mapa[0][i] != current) { cout << "NE" << endl; return; }
            current++;
        }
        cout << "DA" << endl;
    }
}

void input() {
    cin >> N >> M >> Q;
    mapa.resize(N, vector<int>(M));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j)
            cin >> mapa[i][j];

    solve();
    while (Q--) {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb; xa--; ya--; xb--; yb--;
        swap(mapa[xa][ya], mapa[xb][yb]);
        solve();
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    return 0;
}