#include <bits/stdc++.h>
using namespace std;
vector<vector<int>>a;
int dx[]={0,0,1,-1};
int dy[]={1,-1,0,0};
int n,m,q;
bool valid(int x,int y)
{
    return x>=0&&y>=0&&x<n&&y<m;
}
int cur=1;
bool dfs(int x,int y)
{
    if(cur!=a[x][y])return false;
    if(cur==n*m&&a[x][y]==n*m)return true;
    ++cur;
    vector<array<int,3>>v;
    for(int j=0;j<4;++j)
    {
        int xp=x+dx[j];
        int yp=y+dy[j];
        if(valid(xp,yp))
            v.push_back({a[xp][yp],xp,yp});

    }
    sort(v.begin(),v.end());
    for(auto r:v)
    {
        if(dfs(r[1],r[2]))return true;
    }

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    cin>>m>>n>>q;
    a.resize(n);
    int x0,y0;
    for(int i=0;i<n;++i)
    {
        a[i].resize(m);
        for(int j=0;j<m;++j)
        {
            cin>>a[i][j];
            if(a[i][j]==1)
            {
                x0=i;
                y0=j;
            }
        }
    }


    if(dfs(x0,y0))cout<<"DA"<<endl;
    else cout<<"NE"<<endl;

    while(q--)
    {
        cur=1;
        int xa,ya,xb,yb;
        cin>>xa>>ya>>xb>>yb;
        --xa;--ya;--xb;--yb;
        swap(a[xa][ya],a[xb][yb]);
        for(int i=0;i<n;++i)
        {
            for(int j=0;j<m;++j)
                if(a[i][j]==1)
            {
                x0=i;y0=j;
            }
        }
        if(dfs(x0,y0))cout<<"DA"<<endl;
        else cout<<"NE"<<endl;
    }
}