#include <bits/stdc++.h>
using namespace std;

vector<int> dx = {0, 0, -1, 1};
vector<int> dy = {1, -1, 0, 0};
set<pair<int,int>> f;
int n, m, q;

void print() {
    if (f.size() == n * m - 1) {
        cout << "DA" << endl;
        return;
    }
    cout << "NE" << endl;
}

void check(int x, int y, vector<vector<int>> &a) {
    if (x < 1 || x > n || y < 1 || y > m) {
        return;
    }
    for (int i = 0; i < 4; i++) {
        if (a[x][y] > a[x + dx[i]][y + dy[i]]) {
            f.insert({x, y});
            return;
        }
    }
    if (f.find({x, y}) != f.end()) {
        f.erase({x, y});
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> q;
    vector<vector<int>> a(n + 2, vector<int>(m + 2));
    for (int i = 0; i < n + 2; i++) {
        for (int j = 0; j < m + 2; j++) {
            a[i][j] = 1e9;
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            check(i, j, a);
        }
    }
    print();
    while (q--) {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb;
        swap(a[xa][ya], a[xb][yb]);
        check(xa, ya, a); check(xb, yb, a);
        for (int i = 0; i < 4; i++) {
            check(xa + dx[i], ya + dy[i], a);
            check(xb + dx[i], yb + dy[i], a);
        }
        print();
    }
    return 0;
}