#include <bits/stdc++.h>

using namespace std;

void dfs(vector<pair<int, int> > &intervali, vector<bool> &poseceni, int n, int p){
    poseceni[p] = true;
    for(int i = 0; i < n; i++){
        if(!poseceni[i] && ((intervali[i].first <= intervali[p].second && intervali[i].first >= intervali[p].first) ||
            (intervali[i].second <= intervali[p].second && intervali[i].second >= intervali[p].first)))
                dfs(intervali, poseceni, n, i);
    }
}

int prvineposeceni(vector<bool> &poseceni){
    for(int x = 0; x < poseceni.size(); x++){
        if(!poseceni[x]){
            return x;
        }
    }
    return -1;
}

int main()
{
    int n;
    cin >> n;
    vector<pair<int, int> > intervali(n);
    vector<bool> poseceni(n, false);

    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        intervali[i] = make_pair(k, 0);
    }

    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        if(k < intervali[i].first){
            intervali[i].second = intervali[i].first;
            intervali[i].first = k;
        }
        else{
            intervali[i].second = k;
        }
    }

    int rez = 0;
    int m = prvineposeceni(poseceni);
    while(m != -1 && rez < 5){
        dfs(intervali, poseceni, n, m);
        m = prvineposeceni(poseceni);
        rez++;
    }
    cout << rez;
}