#include <bits/stdc++.h>

using namespace std;

bool sekuse(pair<int, int> a, pair<int, int> b){
    if(a.first <= b.first && a.second >= b.second)
        return true;
    if(a.first >= b.first && a.second <= b.second)
        return true;
    return false;
}

void dfs(vector<pair<int, int> > &intervali, vector<bool> &poseceni, int n, int p){
    poseceni[p] = true;
    for(int i = 0; i < n; i++){
        if(!poseceni[i] && sekuse(intervali[i], intervali[p]))
                dfs(intervali, poseceni, n, i);
    }
}

int main()
{
    int n;
    cin >> n;
    vector<pair<int, int> > intervali(n);
    vector<bool> poseceni(n, false);

    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        intervali[i] = make_pair(k, 0);
    }

    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        intervali[i].second = k;
    }

    int rez = 0;
    for(int i = 0; i < n; i++){
        if(!poseceni[i]){
            dfs(intervali, poseceni, n, i);
            rez++;
        }
    }
    cout << rez;
}