#include <bits/stdc++.h>
using namespace std;

vector <int> mat[300005];

int n, m;

bool proveri(){
    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            if(mat[i][j] == 1) continue;
            if(i > 1 && mat[i-1][j] < mat[i][j]) continue;
            if(i < n && mat[i+1][j] < mat[i][j]) continue;
            if(j > 1 && mat[i][j-1] < mat[i][j]) continue;
            if(j < m && mat[i][j+1] < mat[i][j]) continue;
            return 0;
        }
    }
    return 1;
}


int uradi(int i, int j){
    if(mat[i][j] == 1) return 1;
    if(i > 1 && mat[i-1][j] < mat[i][j]) return 1;
    if(i < n && mat[i+1][j] < mat[i][j]) return 1;
    if(j > 1 && mat[i][j-1] < mat[i][j]) return 1;
    if(j < m && mat[i][j+1] < mat[i][j]) return 1;
    return 0;
}

vector <bool> bio[300005];

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int q;
    cin >> n >> m >> q;
    for(int i=1; i<=n; i++){
        mat[i].push_back(0);
        bio[i].push_back(0);
        for(int j=1; j<=m; j++){
            int x;
            cin >> x;
            bio[i].push_back(0);
            mat[i].push_back(x);
        }
    }
    int cnt = 0;
    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            cnt += uradi(i, j);
        }
    }
    if(cnt == n*m) cout << "DA\n";
    else cout << "NE\n";
    while(q--){
        int i1, j1, i2, j2;
        cin >> i1 >> j1 >> i2 >> j2;
        if(i1 > 1 && !bio[i1-1][j1]){
            cnt -= uradi(i1-1, j1);
            bio[i1-1][j1] = 1;
        }
        if(i1 < n && !bio[i1+1][j1]){
            cnt -= uradi(i1+1, j1);
            bio[i1+1][j1] = 1;
        }
        if(j1 > 1 && !bio[i1][j1-1]){
            cnt -= uradi(i1, j1-1);
            bio[i1][j1-1] = 1;
        }
        if(j1 < m && !bio[i1][j1+1]){
            cnt -= uradi(i1, j1+1);
            bio[i1][j1+1] = 1;
        }
        if(!bio[i1][j1]){
            cnt -= uradi(i1, j1);
            bio[i1][j1] = 1;
        }

        if(i2 > 1 && !bio[i2-1][j2]){
            cnt -= uradi(i2-1, j2);
            bio[i2-1][j2] = 1;
        }
        if(i2 < n && !bio[i2+1][j2]){
            cnt -= uradi(i2+1, j2);
            bio[i2+1][j2] = 1;
        }
        if(j2 > 1 && !bio[i2][j2-1]){
            cnt -= uradi(i2, j2-1);
            bio[i2][j2-1] = 1;
        }
        if(j2 < m && !bio[i2][j2+1]){
            cnt -= uradi(i2, j2+1);
            bio[i2][j2+1] = 1;
        }
        if(!bio[i2][j2]){
            cnt -= uradi(i2, j2);
            bio[i2][j2] = 1;
        }

        swap(mat[i1][j1], mat[i2][j2]);

        if(i1 > 1 && bio[i1-1][j1]){
            cnt += uradi(i1-1, j1);
            bio[i1-1][j1] = 0;
        }
        if(i1 < n && bio[i1+1][j1]){
            cnt += uradi(i1+1, j1);
            bio[i1+1][j1] = 0;
        }
        if(j1 > 1 && bio[i1][j1-1]){
            cnt += uradi(i1, j1-1);
            bio[i1][j1-1] = 0;
        }
        if(j1 < m && bio[i1][j1+1]){
            cnt += uradi(i1, j1+1);
            bio[i1][j1+1] = 0;
        }
        if(bio[i1][j1]){
            cnt += uradi(i1, j1);
            bio[i1][j1] = 0;
        }

        if(i2 > 1 && bio[i2-1][j2]){
            cnt += uradi(i2-1, j2);
            bio[i2-1][j2] = 0;
        }
        if(i2 < n && bio[i2+1][j2]){
            cnt += uradi(i2+1, j2);
            bio[i2+1][j2] = 0;
        }
        if(j2 > 1 && bio[i2][j2-1]){
            cnt += uradi(i2, j2-1);
            bio[i2][j2-1] = 0;
        }
        if(j2 < m && bio[i2][j2+1]){
            cnt += uradi(i2, j2+1);
            bio[i2][j2+1] = 0;
        }
        if(bio[i2][j2]){
            cnt += uradi(i2, j2);
            bio[i2][j2] = 0;
        }
        if(cnt == n*m) cout << "DA\n";
        else cout << "NE\n";
        /*if(cnt == n*m) cout << "DA\n";
        else cout << "NE\n";*/
    }
    return 0;
}

/*
3 3 2
1 2 3
4 5 6
7 8 9
1 2 2 2
1 2 2 2
*/

/*
1 3 1
1 2 3
1 2 1 3
*/

/*
1 6 2
2 5 1 4 3 6
1 2 1 1
1 2 1 1
*/