#include <bits/stdc++.h>

using namespace std;

//cringe moram da drzim matricu u vektoru

vector<vector<int>> mat;

int n, m;

int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};

inline bool check(int x, int y) {
    return x >= 0 && x < n && y >= 0 && y < m;
}

bool moze() {
    vector<vector<bool>> marked;
    marked.resize(n);
    for(int i = 0; i < n; ++i) {
        marked[i].resize(m, 0);
    }
    pair<int, int> jed;
    vector<pair<int, int>> gde(n*m+1);
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            gde[mat[i][j]] = {i, j};
            if(mat[i][j] == 1) {
                marked[i][j] = 1;
            }
        }
    }

    for(int tren = 2; tren <= n * m; ++tren) {
        pair<int, int> kor = gde[tren];
        bool found = 0;
        for(int i = 0; i < 4; ++i) {
            pair<int, int> kor2 = {kor.first + dx[i], kor.second + dy[i]};
            if(check(kor2.first, kor2.second)) {
                if(marked[kor2.first][kor2.second]) {
                    found = 1;
                    break;
                }
            }
        }

        if(found^1) {
            return 0;
        }
        marked[kor.first][kor.second] = 1;
    }

    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int q;
    cin >> n >> m >> q;
    mat.resize(n);
    for(int i = 0; i < n; ++i) {
        mat[i].resize(m);
        for(int j = 0; j < m; ++j) {
            cin >> mat[i][j];
        }
    }

    cout << (moze() ? "DA" : "NE") << "\n";

    while(q--) {
        int xa, ya;
        int xb, yb;
        cin >> xa >> ya;
        cin >> xb >> yb;

        swap(mat[xa][ya], mat[xb][yb]);

        cout << (moze() ? "DA" : "NE") << "\n";
    }
}