#include <set>
#include <vector>
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define x first
#define y second
#define IOS ios_base :: sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl "\n"
typedef long long ll;
typedef pair<int, int> pi;
typedef pair<ll, ll> pll;

int mz;

bool has_less(int x, int y, vector<vector<int> > a) {
    int val = a[x][y];
    if (a[x - 1][y] < val || a[x + 1][y] < val || a[x][y - 1] < val || a[x][y + 1] < val) return true;
    return false;
}

bool has_one_bigger(int x, int y, vector<vector<int> > a) {
    int val = a[x][y] + 1;
    if (a[x - 1][y] == val || a[x + 1][y] == val || a[x][y - 1] == val || a[x][y + 1] == val) return true;
    return false;
}

bool doesnt_have_less(int x, int y, vector<vector<int> > a) {
    int val = a[x][y];
    if (a[x - 1][y] > val && a[x + 1][y] > val && a[x][y - 1] > val && a[x][y + 1] > val) return true;
    return false;
}

bool doesnt_have_one_bigger(int x, int y, vector<vector<int> > a) {
    int val = a[x][y] + 1;
    if (a[x - 1][y] != val && a[x + 1][y] != val && a[x][y - 1] != val && a[x][y + 1] != val) return true;
    return false;
}

int main()
{
    IOS;
    int n;
    cin >> n;
    int m, q;
    cin >> m >> q;
    mz = n * m;
    vector<vector<int> > a(n + 2, vector<int>(m + 2, INT_MAX));
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i][j] > 1 && doesnt_have_less(i, j, a)) cnt++;
        }
    }
    if (!cnt) cout << "DA\n"; else cout << "NE\n";
    //cout << cnt << endl;
    for (int i = 0; i < q; i++) {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb;
        set <pi > s1, s2;
        if (s1.count({xa, ya}) == 0 && a[xa][ya] > 1 && !doesnt_have_less(xa, ya, a)) { s1.insert({xa, ya}); cnt++; }
        if (s1.count({xa - 1, ya}) == 0 && a[xa - 1][ya] != INT_MAX && a[xa - 1][ya] > 1 && has_less(xa - 1, ya, a)) { s1.insert({xa - 1, ya}); cnt++; }
        if (s1.count({xa + 1, ya}) == 0 && a[xa + 1][ya] != INT_MAX && a[xa + 1][ya] > 1 && has_less(xa + 1, ya, a)) { s1.insert({xa + 1, ya}); cnt++; }
        if (s1.count({xa, ya - 1}) == 0 && a[xa][ya - 1] != INT_MAX && a[xa][ya - 1] > 1 && has_less(xa, ya - 1, a)) { s1.insert({xa, ya - 1}); cnt++; }
        if (s1.count({xa, ya + 1}) == 0 && a[xa][ya + 1] != INT_MAX && a[xa][ya + 1] > 1 && has_less(xa, ya + 1, a)) { s1.insert({xa, ya + 1}); cnt++; }
        if (s1.count({xb, yb}) == 0 && a[xb][yb] > 1 && !doesnt_have_less(xb, yb, a)) { s1.insert({xb, yb}); cnt++; }
        if (s1.count({xb - 1, yb}) == 0 && a[xb - 1][yb] != INT_MAX && a[xb - 1][yb] > 1 && has_less(xb - 1, yb, a)) { s1.insert({xb - 1, yb}); cnt++; }
        if (s1.count({xb + 1, yb}) == 0 && a[xb + 1][yb] != INT_MAX && a[xb + 1][yb] > 1 && has_less(xb + 1, yb, a)) { s1.insert({xb + 1, yb}); cnt++; }
        if (s1.count({xb, yb - 1}) == 0 && a[xb][yb - 1] != INT_MAX && a[xb][yb - 1] > 1 && has_less(xb, yb - 1, a)) { s1.insert({xb, yb - 1}); cnt++; }
        if (s1.count({xb, yb + 1}) == 0 && a[xb][yb + 1] != INT_MAX && a[xb][yb + 1] > 1 && has_less(xb, yb + 1, a)) { s1.insert({xb, yb + 1}); cnt++; }
        int tmp = a[xb][yb];
        a[xb][yb] = a[xa][ya];
        a[xa][ya] = tmp;
        if (s2.count({xa, ya}) == 0 && a[xa][ya] > 1 && has_less(xa, ya, a)) { s2.insert({xa, ya}); cnt--; }
        if (s2.count({xa - 1, ya}) == 0 && a[xa - 1][ya] != INT_MAX && a[xa - 1][ya] > 1 && has_less(xa - 1, ya, a)) { s2.insert({xa - 1, ya}); cnt--; }
        if (s2.count({xa + 1, ya}) == 0 && a[xa + 1][ya] != INT_MAX && a[xa + 1][ya] > 1 && has_less(xa + 1, ya, a)) { s2.insert({xa + 1, ya}); cnt--; }
        if (s2.count({xa, ya - 1}) == 0 && a[xa][ya - 1] != INT_MAX && a[xa][ya - 1] > 1 && has_less(xa, ya - 1, a)) { s2.insert({xa, ya - 1}); cnt--; }
        if (s2.count({xa, ya + 1}) == 0 && a[xa][ya + 1] != INT_MAX && a[xa][ya + 1] > 1 && has_less(xa, ya + 1, a)) { s2.insert({xa, ya + 1}); cnt--; }
        if (s2.count({xb, yb}) == 0 && a[xb][yb] > 1 && has_less(xb, yb, a)) { s2.insert({xb, yb}); cnt--; }
        if (s2.count({xb - 1, yb}) == 0 && a[xb - 1][yb] != INT_MAX && a[xb - 1][yb] > 1 && has_less(xb - 1, yb, a)) { s2.insert({xb - 1, yb}); cnt--; }
        if (s2.count({xb + 1, yb}) == 0 && a[xb + 1][yb] != INT_MAX && a[xb + 1][yb] > 1 && has_less(xb + 1, yb, a)) { s2.insert({xb + 1, yb}); cnt--; }
        if (s2.count({xb, yb - 1}) == 0 && a[xb][yb - 1] != INT_MAX && a[xb][yb - 1] > 1 && has_less(xb, yb - 1, a)) { s2.insert({xb, yb - 1}); cnt--; }
        if (s2.count({xb, yb + 1}) == 0 && a[xb][yb + 1] != INT_MAX && a[xb][yb + 1] > 1 && has_less(xb, yb + 1, a)) { s2.insert({xb, yb + 1}); cnt--; }
        //cout << cnt << endl;
        if (!cnt) cout << "DA\n"; else cout << "NE\n";
    }
    return 0;
}