#include <set>
#include <vector>
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define x first
#define y second
#define IOS ios_base :: sync_with_stdio(0); cin.tie(0);
#define endl "\n"
typedef long long ll;
typedef pair<int, int> pi;
typedef pair<ll, ll> pll;

int mz, cnt;
vector<vector<int> > a, b, o;

bool has_less(int x, int y) {
    int val = a[x][y];
    if (a[x - 1][y] < val || a[x + 1][y] < val || a[x][y - 1] < val || a[x][y + 1] < val) return true;
    return false;
}

void query(int x, int y) {
    if (o[x][y]) return;
    if (a[x][y] > 1 && !has_less(x, y)) {
        b[x][y] = 1;
    } else {
        --cnt;
        b[x][y] = 0;
    }
    o[x][y] = 1;
}

void check(int x, int y) {
    if (!o[x][y] && a[x][y] > 1 && b[x][y]) {
        cnt++;
        o[x][y] = 1;
    }
}

int main()
{
    int n;
    scanf("%d", &n);
    int m, q;
    scanf("%d%d", &m, &q);
    mz = n * m;
    a = vector<vector<int> >(n + 2, vector<int> (m + 2, INT_MAX));
    b = vector<vector<int> >(n + 2, vector<int> (m + 2));
    o = vector<vector<int> >(n + 1, vector<int> (m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            scanf("%d", &a[i][j]);
            o[i][j] = 0;
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i][j] > 1 && !has_less(i, j)) {
                cnt++;
                b[i][j] = 1;
            } else b[i][j] = 0;
        }
    }
    if (!cnt) cout << "DA\n"; else cout << "NE\n";
    //cout << cnt << endl;
    for (int i = 0; i < q; i++) {
        int xa, ya, xb, yb;
        scanf("%d%d%d%d", &xa, &ya, &xb, &yb);
        check(xa, ya);
        check(xa + 1, ya);
        check(xa - 1, ya);
        check(xa, ya - 1);
        check(xa, ya + 1);
        check(xb, yb);
        check(xb + 1, yb);
        check(xb - 1, yb);
        check(xb, yb + 1);
        check(xb, yb - 1);
        swap(a[xa][ya], a[xb][yb]);
        o[xa][ya] = 0; o[xa + 1][ya] = 0; o[xa - 1][ya] = 0; o[xa][ya + 1] = 0; o[xa][ya - 1] = 0;
        o[xb][yb] = 0; o[xb + 1][yb] = 0; o[xb - 1][yb] = 0; o[xb][yb + 1] = 0; o[xb][yb - 1] = 0;
        query(xa, ya);
        query(xa + 1, ya);
        query(xa - 1, ya);
        query(xa, ya - 1);
        query(xa, ya + 1);
        query(xb, yb);
        query(xb + 1, yb);
        query(xb - 1, yb);
        query(xb, yb + 1);
        query(xb, yb - 1);
        //cout << cnt << endl;
        o[xa][ya] = 0; o[xa + 1][ya] = 0; o[xa - 1][ya] = 0; o[xa][ya + 1] = 0; o[xa][ya - 1] = 0;
        o[xb][yb] = 0; o[xb + 1][yb] = 0; o[xb - 1][yb] = 0; o[xb][yb + 1] = 0; o[xb][yb - 1] = 0;
        if (!cnt) cout << "DA\n"; else cout << "NE\n";
    }
    return 0;
}