#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

int nzd(int a, int b)
{
    if (a%b == 0) return b;
    else return nzd(b, a%b);
}

long long faktorijel(int n)
{
    long long suma(1);
    for (int i = 1; i <= n; ++i)
        suma *= i;
    return suma;
}

vector < vector < int > > nzd_resenja(1001, vector < int >(1001, -1));

int nzdD(int a, int b)
{
    if (nzd_resenja[a][b] != -1) return nzd_resenja[a][b];
    int x;
    if (a%b == 0)
    {
        nzd_resenja[a][b] = b;
        return b;
    }
    else x = nzd(b, a%b);
    nzd_resenja[a][b] = x;
    return x;
}

int main()
{
    int n;
    scanf("%d", &n);

    vector < int > niz(n);

    for (int i = 0; i < n; ++i)
        scanf("%d", &niz[i]);

    sort(niz.begin(), niz.end());

    long long suma(0);

    do
    {
    for (int i = 0; i < n-1; ++i)
    {
        if (n <= 9)
        suma += nzd(niz[i], niz[i+1]) % (1000000007);
        else
        suma += nzdD(niz[i], niz[i+1]) % (1000000007);

        suma %= (1000000007);
    }
    }
    while(next_permutation(niz.begin(), niz.end()));

    int pomnoziti = 1;
    vector < int > sviBrojevi(1000001, 0);
    for (int i = 0; i < n; ++i)
        sviBrojevi[niz[i]]++;

    for (int i = 0; i < sviBrojevi.size(); ++i)
    {
        if (sviBrojevi[i] > 1)
        {
            suma *= (faktorijel(sviBrojevi[i]) % (1000000007));
            suma %= (1000000007);
        }
    }

    printf("%lld", suma);

    return 0;
}