#include <cstdio>
#include <cstdint>
#include <climits>
#include <map>
#include <algorithm>>

#define MAX_N 100000

struct Point
{
    int32_t x, y;
};

uint32_t n;
int32_t x, y;
uint64_t count;
Point points[MAX_N];

int main()
{
    scanf("%u", &n);

    count = 0;
    for (int i = 0; i < n; ++i)
        scanf("%i%i", &points[i].x, &points[i].y);

    std::sort(points, points + n, [](const Point& a, const Point& b) { return a.x < b.x; });

    Point* end = points + n;
    Point* i = points;
    Point* iNext = points + 1;
    Point* j = iNext;

    while (iNext != end)
    {
        while (j != end)
        {
            if (j->x - i->x == j->y - i->y)
                ++count;

            ++j;
        }

        i = iNext;
        ++iNext;
        j = iNext;
    }

    printf("%llu", count);    
    return 0;
}