#include <cstdio>
#include <cstdint>
#include <climits>
#include <map>
#include <algorithm>>

#define MAX_N 100000

struct Point
{
    int32_t x, y;
};

uint32_t n;
int32_t x, y;
uint64_t count;
Point arr[MAX_N];

int main()
{
    scanf("%u", &n);

    count = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%i%i", &x, &y);

        Point* upper = std::upper_bound((Point*)arr, arr + i, (Point){x, y }, [](const Point& a, const Point& b) { return a.x < b.x; });
        memmove(upper + 1, upper, (n - (upper - arr)) * sizeof(Point));
        *upper = {x, y};
    }
    
    Point* end = arr + n;
    Point* i = arr;
    Point* iNext = arr + 1;
    Point* j = iNext;

    while (iNext != end)
    {
        while (j != end)
        {
            if (j->x - i->x == j->y - i->y)
                ++count;

            ++j;
        }

        i = iNext;
        ++iNext;
        j = iNext;
    }

    printf("%llu", count);
    return 0;
}