#include <cstdio>
#include <cstdint>
#include <cstring>
#include <climits>

#define MAX_N 200000

struct Node
{
    uint32_t parentIndex;
    int64_t a;
    int64_t k;
};

uint32_t n;
uint32_t index;
Node nodes[MAX_N];

int main()
{
    scanf("%u", &n);

    memset(nodes, 0, sizeof(Node) * n);
    nodes[0].k = 0;

    for (uint32_t i = 0; i < n; ++i)
        scanf("%lli", &nodes[i].a);

    for (uint32_t i = 1; i < n; ++i)
    {
        scanf("%u", &index);
        nodes[i].parentIndex = index - 1;
    }

    for (uint32_t i = n - 1; i != 0; --i)
        nodes[nodes[i].parentIndex].a += nodes[i].a;

    if (nodes[0].a == 0)
        for (uint32_t i = 0; i < n; ++i)
        {
            nodes[i].k = nodes[i].a + nodes[nodes[i].parentIndex].k;
            printf("%lli ", nodes[i].k);
        }
    else
        printf("-1");

    return 0;
}