#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 3e5+45;

struct zica{
    int l,r,t;
} svi[N];

bool cmp(zica x,zica y){
    if(x.l == y.l) return x.r < y.r;
    return x.l < y.l;
}

int n,a[N],b[N],cnt;
int parent[N],rnk[N];

int skup(int x){
    return (parent[x] == x  ? x : parent[x] = skup(parent[x]));
}

void spoji(int i,int j){
    int x = skup(i),y = skup(j);
    if(x == y) return;
    cnt--;
    if(rnk[x] < rnk[y]){
        parent[x] = y;
    }
    else{
        parent[y] = x;
        if(rnk[x] == rnk[y]) rnk[x]++;
    }
}

bool sece(zica p,zica q){
    if(p.t == 1){
        if(q.t == 1){
            return (q.l <= p.l && q.r >= p.r) || (p.l <= q.l && p.r >= q.r);
        }
        else{
            return (q.l <= p.r && q.r >= p.l) || (p.l <= q.r && p.r >= q.l);
        }
    }
    else{
        if(q.t == 1){
            return (q.l <= p.r && q.r >= p.l) || (p.l <= q.r && p.r >= q.l);
        }
        else{
            return (q.l <= p.l && q.r >= p.r) || (p.l <= q.l && p.r >= q.r);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
        if(a[i] <= b[i]){  /// /
            svi[i] = {a[i],b[i],1};
        }
        else{
            svi[i] = {b[i],a[i],2};
        }
    }

    sort(svi+1,svi+n+1,cmp);

    for(int i = 1; i <= n; i++){
        parent[i] = i;
        rnk[i] = 0;
    }

    /*cout << endl;
    for(int i = 1; i <= n; i++){
        cout << svi[i].l << " " << svi[i].r << " " << svi[i].t << endl;
    }
    cout << endl;*/

    cnt = n;
    zica najd1 = {0,0,1},najd2 = {0,0,2};
    int pos1 = 0,pos2 = 0;
    for(int i = 1; i <= n; ){
        int j = i;

        zica novi1 = {0,0,1},novi2 = {0,0,2};
        int npos1 = 0,npos2 = 0;
        if(svi[i].t == 1){ novi1 = svi[i]; npos1 = i; }
        else{ novi2 = svi[i]; npos2 = i; }



        while(j < n && sece(svi[j],svi[j+1])){
            spoji(j,j+1);
            j++;

            if(svi[j].t == 1 && svi[j].r > novi1.r){ novi1 = svi[j]; npos1 = j; }
            if(svi[j].t == 2 && svi[j].r > novi2.r){ novi2 = svi[j]; npos2 = j; }
        }

        for(int h = i; h <= j; h++){
            if(pos1 && sece(najd1,svi[i])){
                spoji(pos1,h);
                if(najd1.r > novi1.r){ novi1 = najd1; npos1 = pos1; }
            }
            if(pos2 && sece(najd2,svi[i])){
                spoji(pos2,h);
                if(najd2.r > novi2.r){ novi2 = najd2; npos2 = pos2; }
            }
        }

        najd1 = novi1;
        najd2 = novi2;
        pos1 = npos1;
        pos2 = npos2;

        //cout << "za " << i << " stigo do " << j << endl;
        i = j+1;
    }

    cout << cnt << endl;
}