#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int SZ = 3e5+23;

ll n,m,q;
vector <vector<int>> a;
pair <int,int> pos[SZ];
bool da[SZ];

vector <pair<int,int>> dir = {{1,0},{-1,0},{0,1},{0,-1}};
bool ok(int i,int j){
    return (i >= 1 && j >= 1 && i <= n && j <= m);
}

int main(){
    cin >> n >> m >> q;
    vector <int> g(m+1,0);
    a.push_back(g);
    for(int i = 1; i <= n; i++){
        vector <int> v(1,0);
        for(int j = 1; j <= m; j++){
            int x;
            cin >> x;
            pos[x] = {i,j};
            v.push_back(x);
        }
        a.push_back(v);
    }

    ll br = 0;
    for(int i = 1; i < n*m; i++){
        da[i] = (abs(pos[i].first-pos[i+1].first) == 1) || (abs(pos[i].second-pos[i+1].second) == 1);
        br += da[i];
    }

    if(br == n*m-1) cout << "DA\n";
    else cout << "NE\n";

    while(q--){
        int xa,ya,xb,yb;
        cin >> xa >> ya >> xb >> yb;
        int v1 = a[xa][ya],v2 = a[xb][yb];

        if(v1 != n*m){
            if(da[v1]) br--;
            da[v1] = 0;
        }
        if(v2 != n*m){
            if(da[v2]) br--;
            da[v2] = 0;
        }
        if(v1 > 1){
            if(da[v1-1]) br--;
            da[v1-1] = 0;
        }
        if(v2 > 1){
            if(da[v2-1]) br--;
            da[v2-1] = 0;
        }

        swap(a[xa][ya],a[xb][yb]);

        for(auto f : dir){
            if(!ok(xa+f.first,ya+f.second)) continue;
            if(a[xa+f.first][ya+f.second] == v2-1){
                if(!da[v2-1]) br++;
                da[v2-1] = 1;
            }
            if(a[xa+f.first][ya+f.second] == v2+1){
                if(!da[v2]) br++;
                da[v2] = 1;
            }
        }

        for(auto f : dir){
            if(!ok(xb+f.first,yb+f.second)) continue;
            if(a[xb+f.first][yb+f.second] == v1-1){
                if(!da[v1-1]) br++;
                da[v1-1] = 1;
            }
            if(a[xb+f.first][yb+f.second] == v1+1){
                if(!da[v1]) br++;
                da[v1] = 1;
            }
        }

        if(br == n*m-1){
            cout << "DA\n";
        }
        else{
            cout << "NE\n";
        }
    }
}