#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int SZ = 3e5+23;

ll n,m,q;
vector <vector<int>> a;
pair <int,int> pos[SZ];
int manji[SZ];

vector <pair<int,int>> dir = {{1,0},{-1,0},{0,1},{0,-1}};
bool ok(int i,int j){
    return (i >= 1 && j >= 1 && i <= n && j <= m);
}

int main(){
    cin >> n >> m >> q;
    vector <int> g(m+1,0);
    a.push_back(g);
    for(int i = 1; i <= n; i++){
        vector <int> v(1,0);
        for(int j = 1; j <= m; j++){
            int x;
            cin >> x;
            pos[x] = {i,j};
            v.push_back(x);
        }
        a.push_back(v);
    }

    ll br = 0;
    for(int i = 2; i <= n*m; i++){
        int x = pos[i].first,y = pos[i].second;
        for(auto f : dir){
            if(!ok(x+f.first,y+f.second)) continue;
            if(a[x+f.first][y+f.second] < i) manji[i]++;
        }
        br += (manji[i] > 0);
    }

    if(br == n*m-1) cout << "DA\n";
    else cout << "NE\n";

    while(q--){
        int xa,ya,xb,yb;
        cin >> xa >> ya >> xb >> yb;
        int v1 = a[xa][ya],v2 = a[xb][yb];

        /// obrisi ih
        if(v1 != 1){
            if(manji[v1]) br--;
            manji[v1] = 0;
        }
        for(auto f : dir){
            if(!ok(xa+f.first,ya+f.second)) continue;
            int val = a[xa+f.first][ya+f.second];
            if(val == v2) continue;
            if(val > v1){
                manji[val]--;
                if(!manji[val]) br--;
            }
        }
        if(v2 != 1){
            if(manji[v2]) br--;
            manji[v2] = 0;
        }
        for(auto f : dir){
            if(!ok(xb+f.first,yb+f.second)) continue;
            int val = a[xb+f.first][yb+f.second];
            if(val == v1) continue;
            if(val > v2){
                manji[val]--;
                if(!manji[val]) br--;
            }
        }

        /// zameni
        swap(a[xa][ya],a[xb][yb]);

        /// dodaj ih
        for(auto f : dir){
            if(!ok(xa+f.first,ya+f.second)) continue;
            int val = a[xa+f.first][ya+f.second];
            if(val < v2){
                if(!manji[v2]) br++;
                manji[v2]++;
            }
            else if(val != v1){
                if(!manji[val]) br++;
                manji[val]++;
            }
        }
        for(auto f : dir){
            if(!ok(xb+f.first,yb+f.second)) continue;
            int val = a[xb+f.first][yb+f.second];
            if(val < v1){
                if(!manji[v1]) br++;
                manji[v1]++;
            }
            else if(val != v2){
                if(!manji[val]) br++;
                manji[val]++;
            }
        }

        if(br == n*m-1){
            cout << "DA\n";
        }
        else{
            cout << "NE\n";
        }
    }
}