#include <bits/stdc++.h>
using namespace std;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define endl '\n'
#define K int(1e3 + 1)
#define X real()
#define Y imag()
#define EPS 1e-6
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y;
#define MAN(a, b) norm(a, b)
#define EUC(a, b) abs(a, b)
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef complex<double> point;

bool seku(int a1, int b1, int a2, int b2){
    return (a1 <= a2 &&  b1 >= b2) ||
            (a2 <= a1 && b1 <= b2);
}

void dfs(vector<vector<int>> &adj, vector<bool> &vis, int i){
    if (vis[i]) return;
    vis[i] = 1;
    for (int j : adj[i])
        dfs(adj, vis, j);
}

void solve(){
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    if (n <= 5000){
        vector<vector<int>> adj(n);
        vector<bool> vis(n, 0);
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                if (seku(a[i], b[i], a[j], b[j])){
                    adj[i].push_back(j);
                    adj[j].push_back(i);
                }
        int ans = 0;
        for (int i = 0; i < n; i++)
            if (!vis[i]) {++ans, dfs(adj, vis, i);}
        cout << ans << endl;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1; // cin >> t;
    while (t--) solve();

    return 0;
}