#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define endl "\n"

using namespace std;

int binari(vector<pair<int,int>>& komponente, int L, int R, pair<int,int> curr)
{
    int ret;

    while(L<=R) {
        int mid=L+(R-L)/2;

        if(komponente[mid].second>curr.second) {
            ret=mid;
            R=mid-1;
        }
        else
            L=mid+1;
    }

    return ret;
}

void solve()
{
    int n; cin >> n;

    vector<pair<int,int>> v(n);

    for(int i=0;i<n;i++)
        cin >> v[i].first;
    for(int i=0;i<n;i++)
        cin >> v[i].second;

    sort(v.begin(), v.end());

    vector<pair<int,int>> komponente;
    int ans=0;

    for(auto curr:v) {
        if(komponente.empty()) {
            komponente.push_back(curr);
            ans++;
            continue;
        }

        if(curr.second > komponente.back().second) {
            komponente.push_back(curr);
            ans++;
        }
        else {
            int nalevo = binari(komponente, 0, komponente.size()-1, curr);
            int iseceno = komponente.size() - nalevo;
            pair<int,int> novi = make_pair(curr.first, komponente.back().second);
            ans -= iseceno-1;
            komponente.erase(komponente.begin()+nalevo, komponente.end());
            komponente.push_back(novi);
        }

    }

    cout << ans << endl;
}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int t=1; //cin >> t;
    while(t--)
        solve();

    return 0;
}