#include <bits/stdc++.h>

#define k1 zice[i].k
#define n1 zice[i].n

#define k2 zice[j].k
#define n2 zice[j].n

template<typename T>
T* napraviNiz(size_t n){
    return (T*) calloc(n, sizeof(T));
}

struct Tacka{
    double x,y;
};

struct zica{
    double a;
    double b;
};

int orientacija(Tacka p, Tacka q, Tacka r){
    return (q.y-p.y)*(r.x-q.x)-(q.x-p.x)*(r.y-q.y);
}

bool sekuSe(Tacka p1, Tacka q1, Tacka p2, Tacka q2)
{
    int o1 = orientacija(p1, q1, p2);
    int o2 = orientacija(p1, q1, q2);
    int o3 = orientacija(p2, q2, p1);
    int o4 = orientacija(p2, q2, q1);

    if (o1 != o2 && o3 != o4)
        return true;

    return false;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cerr.tie(0);

    int n;
    zica* zice;

    std::cin >> n;

    zice = napraviNiz<zica>(n);

    for(int i=0;i<n;++i) std::cin >> zice[i].a;
    for(int i=0;i<n;++i) std::cin >> zice[i].b;

    std::sort(zice, zice+n, [](zica& a, zica& b){
                    return (a.a < b.a);
                });

    int ostalo = n;

    bool provereni[n] = {false};

    for(int i=0;i<n;++i){
        if(ostalo == 0)
            break;
        for(int j=i+1;j<n;++j){
            Tacka p1 = {zice[i].a, 1};
            Tacka q1 = {zice[i].b, 2};
            Tacka p2 = {zice[j].a, 1};
            Tacka q2 = {zice[j].b, 2};

            if(sekuSe(p1, q1, p2, q2) && (!provereni[i] || !provereni[j])){
                ostalo--;
                provereni[i]=true;
                provereni[j]=true;
            }
        }
    }


    std::cout << ostalo+1;

    return 0;
}