#include <bits/stdc++.h>
using namespace std;

const int N = 300005;
pair<int, int> a[N];

int st[4 * N];
int arr[N];

int getSum(int x, int y, int id, int l, int r){
    if(l > y || r < x)
        return 0;
    if(x <= l && r <= y)
        return st[id];

    int mid = (l + r) / 2;
    int v1 = getSum(x, y, id * 2 + 1, l, mid);
    int v2 = getSum(x, y, id * 2 + 2, mid + 1, r);
    return v1 + v2;
}

void update(int x, int val, int id, int l, int r){
    if(l > x || r < x)
        return;
    if(l == r){
        st[id] = val;
        return;
    }

    int mid = (l + r) / 2;
    update(x, val, id * 2 + 1, l, mid);
    update(x, val, id * 2 + 2, mid + 1, r);

    st[id] = st[id * 2 + 1] + st[id * 2 + 2];
}

int btoarr[N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i].second;
    }
    vector<pair<int, int>> vks;
    for(int i = 0; i < n; ++i){
        cin >> a[i].first;
        vks.push_back({a[i].first, i});
    }
    sort(a, a + n);
    sort(vks.begin(), vks.end());
    for(int i = 0; i < n; ++i){
        btoarr[vks[i].second] = i;
    }

    stack<pair<int, int>> segs;

    int cmax = 0;
    for(int i = 0; i < n; ++i){
        int el = a[i].second;

        if(!segs.empty() && el <= segs.top().second){ //expand prev range
            pair<int, int> top = segs.top();
            segs.pop();
            pair<int, int> nw = {min(top.first, el), cmax}; //cmax to the right
            while(!segs.empty() && segs.top().second >= nw.first){
                nw.first = segs.top().first; //to the left
                segs.pop();
            }
            segs.push(nw);

        }else{ //make new range
            cmax = max(cmax, el);
            segs.push({el, cmax});
        }
    }

    int res = segs.size();
    cout << res << "\n";
    return 0;
}

/*
10
1 4 5 8 9 10 14 15 17 18
3 7 2 9 6 13 11 10 16 19
--
4
*/