#include <bits/stdc++.h>
using namespace std;

const int N = 300005;
pair<int, int> a[N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i].second;
    }
    for(int i = 0; i < n; ++i){
        cin >> a[i].first;
    }
    sort(a, a + n);

    stack<pair<int, int>> segs;

    int cmax = 0;
    for(int i = 0; i < n; ++i){
        int el = a[i].second;

        if(!segs.empty() && el <= segs.top().second){ //expand prev range
            pair<int, int> top = segs.top();
            segs.pop();
            pair<int, int> nw = {min(top.first, el), cmax}; //cmax to the right
            while(!segs.empty() && segs.top().second >= nw.first){
                nw.first = min(segs.top().first, nw.first); //to the left
                segs.pop();
            }
            segs.push(nw);

        }else{ //make new range
            cmax = max(cmax, el);
            segs.push({el, cmax});
        }
    }

    int res = segs.size();
    cout << res << "\n";
    return 0;
}

/*
10
3 7 2 9 6 13 11 10 16 19
1 4 5 8 9 10 14 15 17 18
--
4

15
5 4 3 11 9 15 17 14 8 20 21 19 26 1 29
2 6 7 10 12 13 16 18 19 22 23 24 25 27 28
--
2
*/