#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef pair<int, int> pi;
typedef vector<pi> vp;
typedef vector<double> vd;
typedef vector<long double> vld;

bool ok(int a, int b, int c, int d){
    if (a <= c && b >= d) return 1;
    if (a >= c && b <= d) return 1;
    return 0;
}

const int maxn = 3e5+10;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int n;
    cin >> n;

    vi a(n);
    for (auto& i : a)
        cin >> i;

    vi b(n);
    for (auto& i : b)
        cin >> i;

    set<int> poz;
    map<int, pi> m;
    vi vis(n);
    for (int i = 0; i < n; ++i){
        int k = min(a[i], b[i]);

        if (k == a[i])
            vis[i]=1;

        if (poz.count(k)){
            int ind = m[k].first;
            m[k] = {ind, i};
        } else {
            m[k] = {i,-1};
        }

        poz.insert(k);
    }

    vi st;
    for (auto x : poz)
        st.push_back(x);

    set<int> s, t;
    int sol = 0;
    for (int x : st){
        int ind = m[x].first, ind1 = m[x].second, kb = b[ind], ka = a[ind];

        if (ind1 != -1){
            kb = min(kb, b[ind1]);
            ka = min(ka, a[ind1]);
        }

        while(!s.empty() && (*s.begin()) < kb){
            s.erase(s.begin());
        }

        while(!t.empty() && (*t.begin()) < ka)
            t.erase(t.begin());

        if (t.empty() && s.empty()){
            ++sol;
        }

        if (vis[ind])
            s.insert(b[ind]);
        else
            t.insert(a[ind]);

        ind = ind1;
        if (ind == -1) continue;
        if (vis[ind])
            s.insert(b[ind]);
        else
            t.insert(a[ind]);
    }

    cout << sol << '\n';
}