#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vl;
typedef pair<int, int> pi;
typedef vector<pi> vp;
typedef vector<double> vd;
typedef vector<long double> vld;

int n, m;
vvi a, vis;
vp t;

bool ok(int x, int y){
    if (x >= 0 && y >= 0 && x < n && y < m)
        return 1;
    return 0;
}

vp dir = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

set<pi> s;

void f(){
    if (s.empty())
        cout << "DA\n";
    else
        cout << "NE\n";
}

void check(int x, int y){
    bool oke = (a[x][y] == 0);
    for (auto& i : dir){
        int x1 = x + i.first, y1 = y + i.second;
        if (!ok(x1,y1) || a[x1][y1] > a[x][y]) continue;
        oke = 1;
    }

    if (oke)
        s.erase({x,y});
    else
        s.insert({x, y});
}

void brisi(){
    while(!s.empty())
        s.erase(s.begin());
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int q;
    cin >> n >> m >> q;

    a = vvi(n, vi(m,0));
    vis = a;
    t = vp(n*m);
    auto vis1 = vis;
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j){
        cin >> a[i][j];
        --a[i][j];

        t[a[i][j]] = {i,j};
    }

    for (int e = 0; e <= q; ++e){
        brisi();
        if (e>0){
            int a1,b1,a2,b2;
            cin >> a1 >> b1 >> a2 >> b2;
            --a1; --a2; --b1; --b2;

            swap(t[a[a1][b1]], t[a[a2][b2]]);
            swap(a[a1][b1], a[a2][b2]);
        }

        vis=vis1;
        vis[t[0].first][t[0].second] = 1;
        for (int k = 1; k < n*m; ++k){
            int x = t[k].first, y = t[k].second;

            bool oke = 0;
            for (auto& i : dir){
                int x1 = x + i.first, y1 = y + i.second;
                if (!ok(x1,y1) || !vis[x1][y1]) continue;
                oke = 1;
            }

            if (!oke)
                s.insert({x, y});

            vis[x][y] = 1;
        }

        f();
    }
}