#include <bits/stdc++.h>
using namespace std;
priority_queue <pair<long long, long long>> redA, redB;
long long a[300005], b[300005];
bool visited[300005];
void dfs(long long node, long long n)
{
    long long i;
    for(i = 0; i < n; i++)
        if((a[node] < a[i] && b[node] > b[i]) || (a[node] > a[i] && b[node] < b[i]))
            if(!visited[i])
            {
                visited[i] = 1;
                dfs(i, n);
            }
}
int main()
{
    ios_base::sync_with_stdio(false);
    long long n, x, i, ans = 0;
    cin >> n;
    for(i = 0; i < n; i++) cin >> a[i];
    for(i = 0; i < n; i++) cin >> b[i];

    if(n <= 5000)
    {
       for(i = 0; i < n; i++)
           if(!visited[i])
           {
               ans++;
               visited[i] = 1;
               dfs(i, n);
           }
        cout << ans;
        return 0;
    }



    for(i = 0; i < n; i++)
    {
        redA.push({-a[i], i});
        redB.push({-b[i], i});
    }
    while(redA.size() > 0 && redB.size() > 0)
    {
        while(redA.size() > 0 && visited[redA.top().second] == 1) redA.pop();
        if(redA.size() == 0)
        {
            while(redB.size())
            {
                if(!visited[redB.top().second]) ans++;
                redB.pop();
            }
            break;
        }
        x = redA.top().second;
        redA.pop();
        visited[x] = 1;
        while(redB.size() > 0 && -redB.top().first < b[x])
        {
            visited[redB.top().second] = 1;
            redB.pop();
        }
        if(redB.size() == 0)
        {
            while(redA.size())
            {
                if(!visited[redA.top().second]) ans++;
                redA.pop();
            }
            break;
        }
        ans++;
    }
    cout << ans;
    return 0;
}