#include<iostream>
#include<math.h>
using namespace std;
int nmmax;
int len;
bool* st;
int** tok;
bool na_tabli(int n, int m, int x, int y)
{
    return (x >= 0 && x < n && y >= 0 && y < m);
}
bool okolina(int n, int m, int x, int y)
{
    bool b = 0;
    for(int i = -1; i <= 1; i++)
        for(int j = -1; j <= 1; j++)
            b = (b || ((i == 0 || j == 0) && na_tabli(n, m, x + i, y + j) && tok[x+i][y+j] < tok[x][y]));
    return b;
}
bool gen(int k)
{
    if(k >= len - nmmax && k < len) return st[k];
    st[k] = (gen(2*k+1) && gen(2*k+2));
    return st[k];
}
void osv(int p)
{
    st[p] = (st[2*p+1] && st[2*p+2]);
    if(p == 0) return;
    osv((p-1)/2);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    nmmax = (1<<19);
    st = new bool[2*nmmax-1];
    int n, m, q, x1, y1, xa, xb, ya, yb, pom, poz;
    len = 2*nmmax-1;
    cin >> n >> m >> q;
    tok = new int*[n];
    for(int i = 0; i < n; i++)
    {
        tok[i] = new int[m];
        for(int j = 0; j < m; j++)
        {
            cin >> tok[i][j];
            if(tok[i][j] == 1) x1 = i, y1 = j;
        }
    }
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            st[len - nmmax + i * n + j] = okolina(n, m, i, j);
    st[len - nmmax] = 1;
    for(int i = n * m; i < nmmax; i++) st[len - nmmax + i] = 1;
    //for(int i = 0; i < n * m; i++) cout << st[i+1];
    if(gen(0)) cout << "DA\n";
    else cout << "NE\n";
    while(q--)
    {
        cin >> xa >> ya >> xb >> yb;
        xa--; xb--; ya--; yb--;
        pom = tok[xa][ya];
        tok[xa][ya] = tok[xb][yb];
        tok[xb][yb] = pom;
        for(int i = -1; i <= 1; i++)
            for(int j = -1; j <= 1; j++)
                if((i == 0 || j == 0) && na_tabli(n, m, xa+i, ya+1))
                {
                    poz = len - nmmax + (xa + i) * n + ya + j;
                    st[poz] = okolina(n, m, xa+i, ya+j);
                    osv((poz - 1) / 2);
                }
        for(int i = -1; i <= 1; i++)
            for(int j = -1; j <= 1; j++)
                if((i == 0 || j == 0) && na_tabli(n, m, xb+i, yb+1))
                {
                    poz = len - nmmax + (xb + i) * n + yb + j;
                    st[poz] = okolina(n, m, xb+i, yb+j);
                    osv((poz - 1) / 2);
                }
        if(st[0]) cout << "DA\n";
        else cout << "NE\n";
    }
}