#include <bits/stdc++.h>
#define MAXN 200010
#define LINF 1000000000000000
using namespace std;

vector<int> a[MAXN];
long long dop[MAXN];
long long kop[MAXN];
long long dp[MAXN];

void nadjiDp(int s, int p)
{
    if(dp[s] != -LINF)
        return;

    long long res = 0;
    for(auto x : a[s])
    {
        if(x != p)
        {
            nadjiDp(x, s);
            res += dp[x];
        }
    }
    dp[s] = res + dop[s];
}
void DFS(int s, int p)
{
    kop[s] = dp[s] + kop[p];
    for(auto x : a[s])
    {
        if(x != p)
        {
            DFS(x, s);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        dp[i] = -LINF;
        cin >> dop[i];
    }
    for(int i = 1; i <= n - 1; i++)
    {
        int v;
        cin >> v;
        a[v].push_back(i + 1);
        a[i + 1].push_back(v);
    }
    kop[1] = 0;
    nadjiDp(1, 1);
    /*for(int i = 1; i <= n; i++)
    {
        cout << dp[i] << ", ";
    } cout << endl;*/
    for(auto x : a[1])
    {
        DFS(x, 1);
    }
    long long tmp = 0;
    for(auto x : a[1])
    {
        tmp -= kop[x];
    }
    if(tmp != dop[1])
    {
        cout << -1 << endl;
    }
    else
    {
        for(int i = 1; i <= n; i++)
        {
            cout << kop[i] << " ";
        }
        cout << endl;
    }



    return 0;
}