#include <bits/stdc++.h>
#define ll long long
#define pii pair<ll, ll>
#define s second
#define f first

using namespace std;

const int MAX_N = 3e5 + 5;
ll n, ans;
pii ab[MAX_N];
vector<int> g[MAX_N];
bool visited[MAX_N];

bool intersect(const pii& a,const pii& b){
  return (a.f <= b.f && a.s >= b.s) || (a.f >= b.f && a.s <= b.s);
}

void dfs(int x){
  visited[x] = true;
  for(auto u : g[x]){
    if(visited[u]){continue;}
    dfs(u);
  }
}

int main(){
  cin >> n;
  for(int i = 0; i < n; ++i){
   cin >> ab[i].f;
  }
  for(int i = 0; i < n; ++i){
   cin >> ab[i].s;
  }
  for(int i = 0; i < n; ++i){
    for(int j = 0; j < n; ++j){
      if(intersect(ab[i], ab[j])){
        g[i].push_back(j);
        g[j].push_back(i);
      }
    }
  }
  for(int i = 0; i < n; ++i){
    if(!visited[i]){
      ++ans;
      dfs(i);
    }
  }
  cout << ans << endl;
  return 0;
}