#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MAX_N = 3e5 + 5;
ll n, m, q, xa, ya, xb, yb , posx, posy;
vector<vector<ll>> mat;
vector<bool> visited;
map<ll, pair<ll, ll>> mp;
priority_queue<ll> pq;
int dx[4] = {1, -1, 0, 0}, dy[4] = {0, 0, 1, -1};

bool good(int x, int y){
  return (x >= 0 && x < n && y >= 0 && y < m);
}

bool can(){
  while(!pq.empty()){pq.pop();}
  pq.push(-1);
  ll cnt = 1;
  while(!pq.empty()){
    ll x = -pq.top();
    if(x != cnt){return false;}
    visited[x] = true;
    pq.pop();
    ll xx = mp[x].first;
    ll yy = mp[x].second;
    for(int i = 0; i < 4; ++i){
      if(good(xx + dx[i], yy + dy[i]) && !visited[mat[xx + dx[i]][yy + dy[i]]]){
        pq.push(-mat[xx + dx[i]][yy + dy[i]]);
        visited[mat[xx + dx[i]][yy + dy[i]]] = true;
      }
    }
    ++cnt;
  }
  return true;
}

int main(){
  cin >> n >> m >> q;
  mat.resize(n);
  visited.resize(n * m + 1);
  for(int i = 0; i < n; ++i){
    mat[i].resize(m);
    for(int j = 0; j < m; ++j){
      cin >> mat[i][j];
      mp[mat[i][j]] = {i, j};
    }
  }
  if(can()){cout << "DA" << endl;}
  else{cout << "NE" << endl;}
  while(q--){
    cin >> xa >> ya >> xb >> yb;
    --xa; --ya; --xb; --yb;
    swap(mat[xa][ya], mat[xb][yb]);
    swap(mp[mat[xa][ya]], mp[mat[xb][yb]]);
    visited = vector<bool>(n * m + 1);
    if(can()){cout << "DA" << endl;}
    else{cout << "NE" << endl;}
  }
}