#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define PB push_back
#define vi vector<int>
#define ll long long
#define pii pair<int,int>
#define w(x) cout<<#x<<":"<<x<<endl;

bool safeUtil(vector<vi> &M, vector<vi> &S, int i, int j, int n, int m, bool &valid)
{
    if(i<0 || i>=n || j<0 || j>=m) {valid=false; return 1;}

    int val=M[i][j];
    if(val==1) return 1;

    if(i>0) if(M[i-1][j]<val) return 1;
    if(i<n-1) if(M[i+1][j]<val) return 1;
    if(j>0) if(M[i][j-1]<val) return 1;
    if(j<m-1) if(M[i][j+1]<val) return 1;

    return 0;
}
bool safe(vector<vi> &M, vector<vi> &S, int i, int j, int n, int m)
{
    bool valid=true;
    bool res=safeUtil(M,S,i,j,n,m,valid);
    if(valid) S[i][j]=res;
    return res;
}
bool getSafe(vector<vi> &S, int i, int j, int n, int m)
{
    if(i<0 || i>=n || j<0 || j>=m) return 1;
    return S[i][j];
}

void print(int sc, int u)
{
    if(sc==u) cout<<"DA";
    else cout<<"NE";
    cout<<endl;
}
void solve()
{
    int n,m,Q; cin>>n>>m>>Q;
    vector<vi> M(n,vi(m)), S(n,vi(m));
    for(int i=0; i<n; ++i) for(int j=0; j<m; ++j) cin>>M[i][j];

    int sc=0,u=n*m;
    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            safe(M,S,i,j,n,m);
            sc+=S[i][j];
            //w(i); w(j); w(sc);
        }
    }
    print(sc,u);

    while(Q--)
    {
        int i1,j1,i2,j2; cin>>i1>>j1>>i2>>j2;
        i1--; j1--; i2--; j2--;

        vector<bool> s(10);
        s[0]=getSafe(S,i1,j1,n,m);
        s[1]=getSafe(S,i1+1,j1,n,m);
        s[2]=getSafe(S,i1,j1+1,n,m);
        s[3]=getSafe(S,i1-1,j1,n,m);
        s[4]=getSafe(S,i1,j1-1,n,m);
        s[5]=getSafe(S,i2+1,j2,n,m);
        s[6]=getSafe(S,i2,j2+1,n,m);
        s[7]=getSafe(S,i2-1,j2,n,m);
        s[8]=getSafe(S,i2,j2-1,n,m);
        s[9]=getSafe(S,i2,j2,n,m);

        int sum; for(auto x:s) sum+=x;

        swap(M[i1][j1],M[i2][j2]);

        /*s[0]=safe(M,i1,j1,n,m);
        s[1]=safe(M,i1+1,j1,n,m);
        s[2]=safe(M,i1,j1+1,n,m);
        s[3]=safe(M,i1-1,j1,n,m);
        s[4]=safe(M,i1,j1-1,n,m);
        s[5]=safe(M,i2+1,j2,n,m);
        s[6]=safe(M,i2,j2+1,n,m);
        s[7]=safe(M,i2-1,j2,n,m);
        s[8]=safe(M,i2,j2-1,n,m);
        s[9]=safe(M,i2,j2,n,m);*/

        safe(M,S,i1,j1,n,m);
        safe(M,S,i1+1,j1,n,m);
        safe(M,S,i1,j1+1,n,m);
        safe(M,S,i1-1,j1,n,m);
        safe(M,S,i1,j1-1,n,m);
        safe(M,S,i2+1,j2,n,m);
        safe(M,S,i2,j2+1,n,m);
        safe(M,S,i2-1,j2,n,m);
        safe(M,S,i2,j2-1,n,m);
        safe(M,S,i2,j2,n,m);

        for(auto x:s) sum-=x;

        sc-=sum;
        print(sc,u);
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    int T=1; //cin>>T;
    while(T--)
    {
        solve();
    }
    return 0;
}