#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define PB push_back
#define vi vector<int>
#define ll long long
#define pii pair<int,int>
//#define MOD (ll)1e9+7
#define w(x) cout<<#x<<":"<<x<<endl;


int NMAX=1005;
ll MOD=1e9+7;

ll factorial(int x)
{
    ll f=1;
    for(ll i=2; i<=1ll*x; ++i) f=(f*i)%MOD;
    return f;
}

void print(ll ans)
{
    cout<<ans<<endl;
}

void solve1(vi &a, int n)
{
    ll s=0;
    for(int i=0; i<n-1; ++i)
    {
        for(int j=i+1; j<n; ++j)
        {
            s+=1ll*__gcd(a[i],a[j]);
            s%=MOD;
        }
    }
    ll m=2*factorial(n-1);
    ll ans=(m*s)%MOD;
    //cout<<ans<<endl;
    print(ans);
    //w(s);
}

void solve3(vi &a, int n)
{
    //cout<<"fds";
    map<int,int> mapic;
    set<int> setic;

    for(auto x:a) setic.insert(x), mapic[x]++;

    vi b; for(auto x:setic) b.PB(x);
    int m=b.size();

    if(m>1000) return print(0ll);

    ll s=0;
    for(ll k=0; k<m; ++k)
    {
        ll i=b[k];
        s+=((mapic[i]*(mapic[i]-1)/2)%MOD*i)%MOD; s%=MOD;

        for(ll l=k+1; l<m; ++l)
        {
            ll j=b[l];
            s+=(1ll*__gcd(i,j)*((mapic[i]*mapic[j])%MOD))%MOD; s%=MOD;
        }
    }

    m=(2*factorial(n-1))%MOD;
    ll ans=(m*s)%MOD;
    //cout<<ans<<endl;
    print(ans);
}

void solve2(vi &a, int n)
{
    vector<ll> c(NMAX+1,0);
    for(auto x:a) {if(x>NMAX) return solve3(a,n); c[x]++; }

    ll s=0;
    for(ll i=1; i<=NMAX; ++i)
    {
        s+=((c[i]*(c[i]-1)/2)%MOD*i)%MOD; s%=MOD;

        for(ll j=i+1; j<=NMAX; ++j)
        {
            s+=(1ll*__gcd(i,j)*((c[i]*c[j])%MOD))%MOD; s%=MOD;
        }
    }
    ll m=(2*factorial(n-1))%MOD;
    ll ans=(m*s)%MOD;
    //cout<<ans<<endl;
    print(ans);
    //w(s);
}


void solve()
{
    int n;
    cin>>n;
    vi a(n); for(auto &x:a) cin>>x;


    /// proba
//    n=1000;
//    vi a(n); for(auto &x:a) x=NMAX+5; a[0]=a[1]=a[2]=999; a[3]=6; a[4]=1;


    if(n<=1000) return solve1(a,n);
    else return solve2(a,n);

//    solve3(a,n);
//    solve1(a,n);
//    solve2(a,n);
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    //cout<<MOD<<endl;
    int T=1; //cin>>T;
    while(T--)
    {
        solve();
    }
    return 0;
}