#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define long int64_t
#define ulong uint64_t

#ifdef OFFLINE
    #define logg(x) cerr << #x << ": " << (x) << ", ";
    #define logan(x) cerr << #x << ": " << (x) << "\n";
#else
    #define logg
    #define logan
#endif // OFFLINE

int sub1(int);
int sub2(int);

int a[300'001];
int b[300'001];

int v[300'001];
basic_string<int> g[300'001];

int sgn(int n){
    if(!n) return 0;
    if(n > 0) return 1;
    if(n < 0) return -1;
    return 123;
}

int inter(int i, int j){
    //logg(i); logan(j);
    //logg(a[i]); logg(b[i]); logg(a[j]); logan(b[j]);
    int dira = a[i]-b[i];
    int dirb = a[j]-b[j];
    //logg(dira); logg(dirb); logan(dira*dirb);

    int li = min(a[i], b[i]);
    int ri = max(a[i], b[i]);
    int lj = min(a[j], b[j]);
    int rj = max(a[j], b[j]);

    if(li > lj){
        swap(li, lj);
        swap(ri, rj);
    }

    if(sgn(dira) == sgn(dirb)){
        return li <= lj && rj <= ri;
    }
    //logg(li); logg(ri); logg(lj); logan(rj);
    return !(lj > ri);
}

void mark(int n){
    v[n] = 1;
    for(auto& i : g[n]){
        if(v[i]) continue;
        mark(i);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int n; cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }

    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }

    if(n <= 5000)
        return sub1(n);

    return sub2(n);

}

int sub1(int n){
    int cnt = 0;
    for(int i = 0; i < n; ++i){
        int seen = 0;
        for(int j = 0; j < n; ++j){
            if(j == i) continue;
            if(!inter(i, j)) continue;
            g[i] += j;
            g[j] += i;
        }
    }


    for(int i = 0; i < n; ++i){
        if(v[i]) continue;
        mark(i);
        ++cnt;
    }

    cout << cnt << endl;

    return 0;
}

int sub2(int n){
    int cnt = 0;
    for(int i = 0; i < n; ++i){
        if(v[i]) continue;
        ++cnt;
        v[i] = 1;
        for(int j = i+1; j < n; ++j){
            if(v[j]) continue;
            if(!inter(i, j)) continue;
            v[j] = 1;
        }
    }

    cout << cnt << endl;
    return 0;
}