#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define long int64_t
#define ulong uint64_t

#ifdef OFFLINE
    #define logg(x) cerr << #x << ": " << (x) << ", ";
    #define logan(x) cerr << #x << ": " << (x) << "\n";
#else
    #define logg
    #define logan
#endif // OFFLINE

const int M = 1'000'000'007;

int gcd(int a, int b){
    int t;
    while(a){
        t = a;
        a = b%a;
        b = t;
    }

    return b;

}

long binom(long n){
    long res = (n*(n-1))%M;
    return res;
}

int a[100'001];
int v[1'000'001];
basic_string<int> nums;
long f[1'000'001];

void prep(){
    f[1] = 1;
    for(int i = 2; i <= 1'000'000; ++i){
        f[i] = i*f[i-1];
        f[i] %= M;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    prep();

    int n; cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        if(!v[a[i]])
            nums += a[i];
        ++v[a[i]];
    }

    if(nums.size() == 2){
        int g = gcd(nums[0], nums[1]);
        long sum = 1;

        logg(nums[0]); logan(nums[1]);
        logg(v[nums[0]]); logan(v[nums[1]]);

        long t = (binom(v[nums[0]])*nums[0])%M;
        t += (binom(v[nums[1]])*nums[1])%M;
        t += (2*v[nums[1]]*v[nums[0]]*g)%M;
        sum = (sum*t)%M;
        sum = (sum*f[n-1])%M;
        cout << sum << endl;

    }

    long sum = 0;
    for(int i = 0; i < n; ++i){
        for(int j = i+1; j < n; ++j){
            sum += gcd(a[i], a[j]);
            if(sum > M)
                sum -= M;
        }
    }

    sum *= 2*f[n-1];
    sum %= M;

    cout << sum << endl;

}