#include <iostream>
#include <algorithm>
#include <unordered_map>

using namespace std;

#define xd 3000

static int n, m, nm;
static int niz[xd][xd];
static unordered_map<int, pair<int, int>> lokacije;

void proveri()
{
    int p = 1;
    while (++p <= nm)
    {
        //cout << "trazimo " << p << endl;
        int i = lokacije[p].first, j = lokacije[p].second;
        if (i > 0 && niz[i-1][j] < p)
            continue;
        else if (j > 0 && niz[i][j-1] < p)
            continue;
        else if (j < (m-1) && niz[i][j+1] < p)
            continue;
        else if (i < (n-1) && niz[i+1][j] < p)
            continue;
        cout << "NE\n";
        return;
    }
    cout << "DA\n";
}

int main()
{
    int q;
    cin >> n >> m >> q;
    if (n > xd || m > xd)
        return 1;
    nm = n * m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            cin >> niz[i][j];
            lokacije[niz[i][j]] = make_pair(i, j);
        }
    proveri();
    while (q--)
    {
        int ai, aj, bi, bj;
        cin >> ai >> aj >> bi >> bj;
        ai--; aj--; bi--; bj--;
        lokacije[niz[ai][aj]] = make_pair(bi, bj);
        lokacije[niz[bi][bj]] = make_pair(ai, aj);
        swap(niz[ai][aj], niz[bi][aj]);
        proveri();
        swap(niz[ai][aj], niz[bi][aj]);
        lokacije[niz[ai][aj]] = make_pair(ai, aj);
        lokacije[niz[bi][bj]] = make_pair(bi, bj);
    }
    return 0;
}