#include <bits/stdc++.h>

#define pb push_back
#define MAXN 300010

using namespace std;

class subset {
public:
    int parent, r;
    subset() {
        parent = -1;
        r = 0;
    }
};

subset s[MAXN];
int ans;

int fnd(int x) {
    if(s[x].parent == -1)
        return x;
    return fnd(s[x].parent);
}

void unite(int x, int y) {

    int a = fnd(x), b = fnd(y);
    if(a == b)
        return;
    ans--;
    if(s[a].r > s[b].r) {
        s[b].parent = a;
        s[a].r = max(s[a].r, s[b].r + 1);
    } else {
        s[a].parent = b;
        s[b].r = max(s[b].r, s[a].r + 1);
    }
}

pair<int, int> rev(pair<int, int> a) {

    return {a.second, a.first};
}

void solve(pair<int, int> arr[], int n) {

    set< pair<int, int> > s1, s2;
    for(int i = 0; i < n; i++) {
        s1.insert(arr[i]);
        s2.insert(rev(arr[i]));
    }

    int sol = 0;
    while(!s1.empty()) {
        auto k1 = *s1.begin();
        auto k2 = rev(k1);
        int a = k1.first, b = k1.second;

        auto it = s2.lower_bound(k2);
        vector< pair<int, int> > v;
        for(auto i = it; ; i--) {
            v.pb(*i);
            if(i == s2.begin())
                break;
        }
        for(auto x: v) {
            s2.erase(x);
            s1.erase(rev(x));
        }
        sol++;
    }
    cout << sol << endl;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    ans = n;

    pair<int, int> arr[n];
    for(int i = 0; i < n; i++)
        cin >> arr[i].first;
    for(int i = 0; i < n; i++)
        cin >> arr[i].second;
    sort(arr, arr + n);

    set< pair<int, int> > s;
    map< pair<int, int>, int > index;
    for(int i = 0; i < n; i++) {
        s.insert(rev(arr[i]));
        index[arr[i]] = i;
    }

    for(int i = 0; i < n; i++) {
        auto it = s.lower_bound(rev(arr[i]));
        int b = 0;
        for(auto i = it; ; i--) {
            b++;
            if(b >= 7 && n > 5000) {
                solve(arr, n);
                return 0;
            }
            unite(index[rev(*it)], index[rev(*i)]);
            if(i == s.begin())
                break;
            }
        s.erase(rev(arr[i]));
    }
    cout << ans << endl;
    return 0;
}