#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const int mxN = 4e5;
const int mod = 1e9+7;

int m, n;
vector<int> mp[mxN];
bool e(int y, int x)
{
    return x>=0 && x < n && y >= 0 && y < m;
}
int dy[4] = {0, 1, 0, -1};
int dx[4] = {1, 0, -1, 0};
bool isok(int y, int x)
{
    if(mp[y][x] == 1) return true;
    for(int k = 0; k < 4; k++)
    {
        int y1 = y + dy[k], x1 = x + dx[k];
        if(e(y1, x1))
        {
            if(mp[y1][x1] < mp[y][x]) return true;
        }
    }
    return false;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q; cin >> m >> n >> q;
    for(int j = 0; j < m; j++)
    {
        mp[j] = vector<int>(n);
        for(int i = 0; i < n; i++)
        {
            cin >> mp[j][i];
        }
    }
    int bad = 0;
    for(int j = 0; j < m; j++)
    {
        for(int i = 0; i < n; i++)
        {
            bad += !isok(j, i);
        }
    }
    if(bad) cout << "NE\n";
    else cout << "DA\n";
    while(q--)
    {
        int y1, x1, y2, x2; cin >> y1 >> x1 >> y2 >> x2;
        y1--, x1--, y2--, x2--;
        set<pair<int, int>> tocheck;
        tocheck.insert({y1, x1});
        tocheck.insert({y2, x2});
        for(int i = 0; i < 4; i++)
        {
            int y = y1+dy[i], x = x1+dx[i];
            if(e(y, x)) tocheck.insert({y, x});
            y = y2+dy[i], x = x2+dx[i];
            if(e(y, x)) tocheck.insert({y, x});
        }
        for(auto par : tocheck)
        {
            if(!isok(par.first, par.second)) bad--;
        }
        swap(mp[y1][x1], mp[y2][x2]);
        for(auto par : tocheck)
        {
            if(!isok(par.first, par.second)) bad++;
        }
        cout << (bad ? "NE\n" : "DA\n");
    }
}