#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;
typedef long long ll;
struct line
{
	ll x, y;
};

bool comp_by_x(const line& lhs, const line& rhs)
{
	return lhs.x < rhs.x;
}

bool operator>(const line& lhs, const line& rhs)
{
	return lhs.y > rhs.y;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n; cin >> n;
	vector<line> lines(n);
	for (int i = 0; i < n; i++)
		cin >> lines[i].x;
	for (int i = 0; i < n; i++)
		cin >> lines[i].y;	
	priority_queue<ll> pq;
	sort(lines.begin(), lines.end(), comp_by_x);

	for (int i = 0; i < n; i++)
	{
		ll greates_y = lines[i].y;
		while (!pq.empty() && pq.top() > lines[i].y)
		{
			greates_y = max(greates_y, pq.top());
			pq.pop();
		}
		pq.push(greates_y);
	}
	cout << pq.size();


	return 0;
}