#include <iostream>
#include <vector>
#include <set>
#define forn(i, n) for (int i = 0; i < n; i++)
using namespace std;
int n, m, q;
vector<vector<int>> a;
#define pii pair<int, int>
set<pii> err;
int add[][2] = {{0, 0}, {0, 1}, {0, -1}, {1, 0}, {-1, 0}};
bool inb(int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < m;
}
bool ok(int x, int y) {
    if (a[x][y] == 0) return true;
    for (int i = 1; i < 5; i++) {
        int xx = x + add[i][0], yy = y + add[i][1];
        if (!inb(xx, yy)) continue;
        if (a[xx][yy] < a[x][y]) return true;
    }
    return false;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> q;
    forn(i, n) a.push_back(vector<int>(m));
    forn(i, n) forn(j, m) cin >> a[i][j], a[i][j]--;
    forn(i, n) forn(j, m) if (!ok(i, j)) err.insert({i, j});
    cout << (err.empty() ? "DA" : "NE") << endl;
    forn(_q, q) {
        int xa, ya, xb, yb;
        cin >> xa >> ya >> xb >> yb;
        xa--, ya--, xb--, yb--;
        swap(a[xa][ya], a[xb][yb]);
        for (int* e: add) {
            int xx = xa + e[0], yy = ya + e[1];
            if (!inb(xx, yy)) continue;
            if (err.count({xx, yy})) {
                if (ok(xx, yy)) err.erase({xx, yy});
            } else {
                if (!ok(xx, yy)) err.insert({xx, yy});
            }
        }
        for (int* e: add) {
            int xx = xb + e[0], yy = yb + e[1];
            if (!inb(xx, yy)) continue;
            if (err.count({xx, yy})) {
                if (ok(xx, yy)) err.erase({xx, yy});
            } else {
                if (!ok(xx, yy)) err.insert({xx, yy});
            }
        }
        cout << (err.empty() ? "DA" : "NE") << endl;
    }
}