#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<int,int> pii;
const int maxn = 300005;
const int inf = 1e9 + 5;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) 
// *os.find_by_order(k)

int n, m, q;

int niz[maxn];
int poz[maxn];

bool resi1(){
	int L = poz[1], R = poz[1];
	ff(i,2,m){
		int X = poz[i];
		
		
		if(L != 1 && L - 1 == X){
			L -= 1;
			continue;			
		}
		
		if(R != m && R + 1 == X){
			R += 1;
			continue;
		}
		
		return 0;
		
	}
	
	return 1;
	
}

void solve1(){
	ff(i,1,m)cin >> niz[i], poz[niz[i]] = i;
	
	cout << (resi1() == 1 ? "DA" : "NE") << '\n';
	
	while(q--){
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		
		int A = niz[b], B = niz[d];
		swap(poz[A], poz[B]);
		swap(niz[b], niz[d]);
		
		cout << (resi1() == 1 ? "DA" : "NE") << '\n';
		
	}
	
}

pii pos[maxn];

int dx[] = {-1, 0, 1, 0}, dy[] = {0, -1, 0, 1};

void solve2(){
	vector<vector<int>> mat(n, vector<int>(m));
	ff(i,0,n - 1){
		ff(j,0,m - 1){
			cin >> mat[i][j], mat[i][j]--;
			pos[mat[i][j]] = {i, j};
		}
	}	
	
	auto resi2 = [&](){
		vector<vector<int>> bio(n, vector<int>(m, 0));
	
		bio[pos[0].fi][pos[0].se] = 1;
		ff(i,1,n * m - 1){
			int x = pos[i].fi, y = pos[i].se;
			
//			cout << "state: " << x << " " << y << endl;
			
			bool ok = 0;
			ff(j,0,3){
				int nwx = x + dx[j];
				int nwy = y + dy[j];
				if(nwx >= 0 && nwx < n && nwy >= 0 && nwy < m){
//					cout << "nova: " << nwx << " " << nwy << endl;
					if(bio[nwx][nwy] == 1){
						ok = 1;
						break;
					}
				}
				
			}
			
			if(!ok)return 0;
			bio[x][y] = 1;
						
		}
		return 1;
			
	};
		
	cout << (resi2() == 1 ? "DA" : "NE") << '\n';
	
	while(q--){
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--, c--, d--;
		
		int A = mat[a][b], B = mat[c][d];
		swap(pos[A], pos[B]);
		swap(mat[a][b], mat[c][d]);
		
		cout << (resi2() == 1 ? "DA" : "NE") << '\n';
		
	}
	
		
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n >> m >> q;
	
	if(n == 1){
		solve1();
		return 0;
	}
	
	if(q <= 200){
		solve2();
		return 0;
	}
	
	return 0;
}
/*

1 5 2
2 1 3 4 5
1 1 1 3 
1 2 1 5

1 5 1
1 2 3 4 5
1 1 1 2

*/