#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<int,int> pii;
const int maxn = 100005;
const int inf = 1e9 + 5;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) 
// *os.find_by_order(k)

int n;
int niz[maxn];

const int mod = 1e9 + 7;
ll add(ll a, ll b){
	return (a + b) % mod;
}
ll sub(ll a, ll b){
	return (a - b + mod) % mod;
}
ll mul(ll a, ll b){
	return (a * b) % mod;
}
ll power(ll a, ll b){
	if(!b)return 1;
	ll pola = power(a, b / 2);
	pola = mul(pola, pola);
	if(b % 2 == 1)pola = mul(pola, a);
	return pola;
}
ll inv(ll a){
	return power(a, mod - 2);
}	

ll fak[maxn];
ll invz[maxn];

void init(){
	fak[0] = 1;
	ff(i,1,n)fak[i] = mul(fak[i - 1], i);
	ff(i,0,n)invz[i] = inv(fak[i]);
}

ll bin(int a, int b){
//	n nad (n - k)
	return mul(fak[a], mul(invz[b], invz[a - b]));
}

void solve2(){
	init();
	
	ll rez = 0;
	ff(i,1,n){
		fb(j,i - 1,1){
			ll kol = mul(2, mul(fak[n - 2], (n - 1)));
			rez = add(rez, mul(kol, __gcd(niz[i], niz[j])));
		}
	}

	cout << rez << endl;
	
}

int cnt[maxn];
void solve3(){
	init();
	ll kol = mul(2, mul(fak[n - 2], (n - 1)));
	
	ff(i,1,n)cnt[niz[i]] += 1;
	
	ll rez = 0;
	const int N = 1000;
	ff(i,1,N){
		if(cnt[i] == 0)continue;
		
		ff(j,i,N){
			if(cnt[j] == 0)continue;
			
			if(i == j){
				if(cnt[i] == 1)continue;
				
				rez = add(rez, mul(mul(kol, bin(cnt[i], 2)), i)); 
				
			}
			else rez = add(rez, mul(mul(kol, mul(cnt[i], cnt[j])), __gcd(i, j)));
		}
		
	}
	
	cout << rez << endl;
				
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	ff(i,1,n)cin >> niz[i];
		
	if(n <= 1000){
		solve2();
		return 0;
	}
	
	if(1){
		solve3();
		return 0;
	}
	
	return 0;
}
/*



*/